/'

	FB-SNARL
	Version 1.02
	Copyright  2011 by Erich Kohl
	All Rights Reserved
	
	Written in FreeBASIC
	Compile as Windows GUI

	Feel free to hack away at this
	for your own personal enjoyment.
	Just let me know about any of
	the changes you make.
	
'/

#Include "windows.bi"
#Include "fbgfx.bi"
#Include "file.bi"

Const GRID_WALL = 1
Const GRID_CORRIDOR_TEMP = 2
Const GRID_CORRIDOR = 3
Const GRID_PATH_USER = 4

Const SIDE_TOP = 0
Const SIDE_RIGHT = 1
Const SIDE_BOTTOM = 2
Const SIDE_LEFT = 3

Const DIR_UP = 0
Const DIR_RIGHT = 1
Const DIR_DOWN = 2
Const DIR_LEFT = 3

Type T_PELLET_POISON
	Row As UByte
	Col As UByte
End Type

Type T_PELLET_BONUS
	Row As UByte
	Col As UByte
	Available As Integer
End Type

Type T_HIGH_SCORES
	High_Name As String * 20
	High_Date As String * 10
	High_Level As UShort
	High_Score As UInteger
End Type

Declare Sub Draw_Title_Screen()
Declare Sub Game_Over()
Declare Sub Get_User_Name()
Declare Sub Help()
Declare Sub High_Scores_Load()
Declare Sub High_Scores_Save()
Declare Sub High_Scores_View()
Declare Sub Init_Globals()
Declare Sub Keyboard_Clear()
Declare Sub Level_Complete()
Declare Sub Level_Generate()
Declare Sub Level_Play()
Declare Sub Level_Up()
Declare Sub Pellets_Collision_Test()
Declare Sub Pellets_Move()
Declare Sub Play_Game()
Declare Sub Player_Die()
Declare Sub Program_Begin()
Declare Sub Program_Main()
Declare Sub Window_Set_Icon()
Declare Function Center_Col(s As String) As Integer

Dim Shared KEY_ENTER As String
Dim Shared KEY_P As String
Dim Shared KEY_F1 As String
Dim Shared KEY_H As String
Dim Shared KEY_ESC As String
Dim Shared KEY_BACKSPACE As String
Dim Shared KEY_ARROW_LEFT As String
Dim Shared KEY_C As String
Dim Shared KEY_Y As String

Dim Shared COLOR_BLUE As UInteger
Dim Shared COLOR_CYAN_LIGHT As UInteger
Dim Shared COLOR_CYAN_DARK As UInteger
Dim Shared COLOR_GREEN As UInteger
Dim Shared COLOR_MAGENTA As UInteger
Dim Shared COLOR_RED As UInteger
Dim Shared COLOR_WHITE As UInteger
Dim Shared COLOR_YELLOW As UInteger

Dim Shared Maze(1 To 140, 1 To 100) As UByte
Dim Shared Pellets_Poison(1 To 25) As T_PELLET_POISON
Dim Shared Pellets_Bonus(1 To 5) As T_PELLET_BONUS
Dim Shared Total_Poison_Pellets As UByte
Dim Shared Score As UInteger
Dim Shared Level As UShort
Dim Shared Lives As UByte
Dim Shared Start_Row As UByte
Dim Shared Start_Col As UByte
Dim Shared End_Row As UByte
Dim Shared End_Col As UByte
Dim Shared Died As Integer
Dim Shared Finished As Integer
Dim Shared Clean_Run As Integer
Dim Shared High_Scores(1 to 10) As T_HIGH_SCORES
Dim Shared Player_Name As String * 20
Dim Shared AppData_Dir As String
Dim Shared Tenth_Second As ULongInt
Dim Shared Quit_Game As Integer

Program_Begin()
Program_Main()

End
Function Center_Col(s As String) As Integer
	
	Return 51 - Int((Len(s) / 2) + .5)
	
End Function
Sub Draw_Title_Screen()

	Dim Row As UByte
	Dim a As UByte
	Dim s As String

	Cls

	Color COLOR_BLUE, 0
	
	Locate 19, 34
	Print Chr(218);String(3, 196);
	For a = 1 To 7
		Print Chr(194);String(3, 196);
	Next a
	Print Chr(191)

	Locate 20, 34
	For a = 1 To 8
		Print Chr(179);Spc(3);
	Next a
	Print Chr(179)

	Locate 21, 34
	Print Chr(180);
	For a = 1 To 7
		Print Spc(3);Chr(179);
	Next a
	Print Spc(3);Chr(195)

	Locate 22, 34
	For a = 1 To 8
		Print Chr(179);Spc(3);
	Next a
	Print Chr(179)

	Locate 23, 34
	Print Chr(192);String(3, 196);
	For a = 1 To 7
		Print Chr(193);String(3, 196);
	Next a
	Print Chr(217)

	Locate 21, 24
	Print String(10, 196)
	Locate 21, 67
	Print String(10, 196)
	Locate 21, 23
	Print Chr(218)
	Locate 21, 77
	Print Chr(191)
	For Row = 22 To 55
		Locate Row, 23
		Print Chr(179)
		Locate Row, 77
		Print Chr(179)
	Next Row
	Locate 56, 23
	Print Chr(192);String(53, 196); Chr(217)
	s = String(33, 196)
	For Row = 1 To 18
		Locate Row, Center_Col(s)
		Print s
	Next Row
	For Row = 57 To 75
		Locate Row, Center_Col(s)
		Print s;
	Next Row

	Color COLOR_MAGENTA, 0
	
	For a = 1 To 8
		Locate 21, 36 + ((a - 1) * 4)
		Print Mid("FB-SNARL", a, 1)
	Next a

	Color COLOR_CYAN_LIGHT, 0

	s = "FB-SNARL 1.02"
	Locate 27, Center_Col(s)
	Print s
	s = "Written in FreeBASIC"
	Locate 29, Center_Col(s)
	Print s
	s = "Copyright (C) 2011 by Erich Kohl"
	Locate 31, Center_Col(s)
	Print s
	s = "All Rights Reserved"
	Locate 33, Center_Col(s)
	Print s

	Color COLOR_WHITE, 0
	
	s = "ENTER.......................Play"
	Locate 37, Center_Col(s)
	Print s
	s = Chr(27) & Chr(24) & Chr(25) & Chr(26) & "........................Move"
	Locate 40, Center_Col(s)
	Print s
	s = "P..........................Pause"
	Locate 43, Center_Col(s)
	Print s
	s = "F1..........................Help"
	Locate 46, Center_Col(s)
	Print s
	s = "H....................High Scores"
	Locate 49, Center_Col(s)
	Print s
	s = "ESC.........................Quit"
	Locate 52, Center_Col(s)
	Print s
		
End Sub
Sub Game_Over()

	Dim Rec As Byte
	Dim High_Score_Pos As UByte
	Dim Row As UByte
	Dim r As UByte
	Dim g As UByte
	Dim b As UByte
	Dim s As String
	
	Cls
	
	s = "= = =   G A M E   O V E R !   = = ="
	
	For Row = 1 To 32
		r = Int(206 * Rnd) + 50
		g = Int(206 * Rnd) + 50
		b = Int(206 * Rnd) + 50
		Color RGB(r, g, b), 0
		Locate Row, Center_Col(s)
		Print s
	Next Row

	For Row = 44 To 75
		r = Int(206 * Rnd) + 50
		g = Int(206 * Rnd) + 50
		b = Int(206 * Rnd) + 50
		Color RGB(r, g, b), 0
		Locate Row, Center_Col(s)
		Print s;
	Next Row
	
	s = "FINAL SCORE = " & Trim(Str(Score))
	Color COLOR_YELLOW, 0
	Locate 36, Center_Col(s)
	Print s
	
	High_Score_Pos = 0

	For Rec = 1 To 10
		If Score > High_Scores(Rec).High_Score Then
			High_Score_Pos = Rec
			Exit For
		EndIf
	Next Rec
	
	Color COLOR_WHITE, 0

	If High_Score_Pos = 0 Then
		s = "Press Enter to continue..."
		Locate 40, Center_Col(s)
		Print s
		Keyboard_Clear()
		Do
		Loop Until InKey() = KEY_ENTER
	Else
		s = "You got a high score.  Enter your name:                     "
		Locate 40, Center_Col(s)
		Print s
		Get_User_Name()
		If Len(RTrim(Player_Name)) <> 0 Then
			If High_Score_Pos < 10 Then
				For Rec = 10 To (High_Score_Pos + 1) Step -1
					High_Scores(Rec) = High_Scores(Rec - 1)
				Next Rec
			EndIf
			High_Scores(High_Score_Pos).High_Name = Player_Name
			High_Scores(High_Score_Pos).High_Date = Date()
			High_Scores(High_Score_Pos).High_Level = Level - 1
			High_Scores(High_Score_Pos).High_Score = Score
		EndIf
		High_Scores_Save()
	EndIf
	
End Sub
Sub Get_User_Name()
	
	Dim Cursor As UByte
	Dim Key_Press As String
	Dim s As String
	
	s = Space(20)
	Mid(s, 1) = RTrim(Player_Name)
	Cursor = Len(RTrim(s)) + 1
	
	Color COLOR_YELLOW, COLOR_BLUE
	
	Do
		Locate 40, 61
		Print s
		Do
			Key_Press = Inkey()
		Loop While Len(Key_Press) = 0
		If Asc(Key_Press) >= 32 And Asc(Key_Press) <= 126 Then
			If Cursor < 21 Then
				Mid(s, Cursor, 1) = Key_Press
				Cursor += 1
			EndIf
		ElseIf Key_Press = KEY_BACKSPACE Or Key_Press = KEY_ARROW_LEFT Then
			If Cursor > 1 Then
				Mid(s, Cursor - 1, 1) = " "
				Cursor -= 1
			EndIf
		EndIf
	Loop Until Key_Press = KEY_ENTER
	
	Player_Name = LTrim(RTrim(s))
	
	Color , 0

End Sub
Sub Help
	
	Dim s As String
	
	Cls
	
	s = "F     B     -     S     N     A     R     L                  H     E     L     P"
	Color COLOR_MAGENTA, 0
	Locate 9, Center_Col(s)
	Print s
	
	s = String(80, 196)
	Color COLOR_BLUE, 0
	Locate 10, Center_Col(s)
	Print s
	
	Color COLOR_CYAN_LIGHT, 0
	Locate 12, 11
	Print "Welcome to FB-Snarl.  This is a game in which you have to navigate a maze in    "
	Locate 14, 11
	Print "order to accumulate points and reach the next level.  At the start of each      "
	Locate 16, 11
	Print "level, a new maze will be generated.  Use the arrow keys to move around.  A     "
	Locate 18, 11
	Print "green arrow will point to the entrance of the maze, and a red arrow will point  "
	Locate 20, 11
	Print "to the exit.  Your goal is to reach that exit.                                  "
	Locate 24, 11
	Print "You begin the game with ten lives.  You can lose a life in one of two ways: By  "
	Locate 26, 11
	Print "crossing paths with one of the red poison pellets that populate each maze, or by"
	Locate 28, 11
	Print "running out of time before you reach the exit (you have a maximum of five       "
	Locate 30, 11
	Print "minutes to accomplish this).  Each time you lose a life, a new maze will be     "
	Locate 32, 11
	Print "generated, but you will still be on the same level.  The game ends when you run "
	Locate 34, 11
	Print "out of lives.                                                                   "
	Locate 38, 11
	Print "Scoring is handled in several ways.  You earn points for every single step that "
	Locate 40, 11
	Print "your path covers when you navigate through the maze, so the more you explore,   "
	Locate 42, 11
	Print "the more points you earn.  You can also eat the yellow bonus pellets for ad-    "
	Locate 44, 11
	Print "ditional points.  Also, if you perform a " & Chr(34) & "clean run" & Chr(34) & " when you complete a"
	Locate 46, 11
	Print "level -- that is, without losing a life -- the points you earn for that level   "
	Locate 48, 11
	Print "are doubled before they are added to your total score.  Finally, the basic      "
	Locate 50, 11
	Print "points you achieve for how much area you cover and for the number of bonus pel- "
	Locate 52, 11
	Print "lets you consume are also multiplied by the level number you are on.            "
	Locate 56, 11
	Print "Variety in this game is achieved via the fact that every maze will be different "
	Locate 58, 11
	Print "in layout and complexity, and the number of poison pellets that you have to deal"
	Locate 60, 11
	Print "with will vary as well, ranging from just a few to twenty-five or more.  Some   "
	Locate 62, 11
	Print "parts of each level will have corridors that go absolutely nowhere!  In summary,"
	Locate 64, 11
	Print "I had fun creating this game, and I hope you have fun playing it, too.          "
	
	s = String(80, 196)
	Color COLOR_BLUE, 0
	Locate 66, Center_Col(s)
	Print s
	
	s = "Press Esc to return to the main menu."
	Color COLOR_WHITE, 0
	Locate 67, Center_Col(s)
	Print s
	
	Keyboard_Clear()
	
	Do
	Loop Until InKey() = KEY_ESC
	
End Sub
Sub High_Scores_Load
	
	Dim Rec As UByte
	
	If FileLen(AppData_Dir & "\FB-Snarl\Scores.dat") = 360 Then
		Open AppData_Dir & "\FB-Snarl\Scores.dat" For Binary As #1
		For Rec = 1 To 10
			Get #1, , High_Scores(Rec).High_Name
			Get #1, , High_Scores(Rec).High_Date
			Get #1, , High_Scores(Rec).High_Level
			Get #1, , High_Scores(Rec).High_Score
		Next Rec
		Close #1
	Else
		For Rec = 1 To 10
			High_Scores(Rec).High_Name = "<EMPTY>             "
			High_Scores(Rec).High_Date = "01/01/1980"
			High_Scores(Rec).High_Level = 0
			High_Scores(Rec).High_Score = 0
		Next Rec
	EndIf
	
End Sub
Sub High_Scores_Save
	
	Dim Rec As UByte
		
	If Len(Dir(AppData_Dir & "\FB-Snarl", &H10)) = 0 Then
		MkDir(AppData_Dir & "\FB-Snarl")
	EndIf

	Kill AppData_Dir & "\FB-Snarl\Scores.dat"
			
	Open AppData_Dir & "\FB-Snarl\Scores.dat" For Binary As #1
	
	For Rec = 1 To 10
		Put #1, , High_Scores(Rec).High_Name
		Put #1, , High_Scores(Rec).High_Date
		Put #1, , High_Scores(Rec).High_Level
		Put #1, , High_Scores(Rec).High_Score
	Next Rec
	
	Close #1
	
End Sub
Sub High_Scores_View
	
	Dim Rec As UByte
	Dim Key_Press As String
	Dim a As UByte
	Dim s As String
	
	Cls
	
	s = "H     I     G     H          S     C     O     R     E     S"
	Color COLOR_MAGENTA, 0
	Locate 20, Center_Col(s)
	Print s
	s = String(60, 196)
	Color COLOR_BLUE, 0
	Locate 21, Center_Col(s)
	Print s
	Locate 55, Center_Col(s)
	Print s
	Locate
	
	Do
		Color COLOR_WHITE, 0
		Locate 23, 21
		Print "NAME                     DATE           LEVEL     SCORE" 
		For Rec = 1 To 10
			If Rec Mod 2 = 0 Then
				Color COLOR_CYAN_LIGHT, 0
			Else
				Color COLOR_CYAN_DARK, 0
			EndIf
			Locate 23 + (Rec * 3), 21
			If High_Scores(Rec).High_Name <> "<EMPTY>             " Then
				Print High_Scores(Rec).High_Name;
			Else
				Print "-";
			EndIf
			Locate , 46
			If High_Scores(Rec).High_Date <> "01/01/1980" Then
				Print High_Scores(Rec).High_Date;
			Else
				Print "-";
			EndIf
			Locate , 61
			If High_Scores(Rec).High_Level <> 0 Then
				Print Trim(Str(High_Scores(Rec).High_Level));
			Else
				Print "-";
			EndIf
			Locate , 71
			If High_Scores(Rec).High_Score <> 0 Then
				Print Trim(Str(High_Scores(Rec).High_Score));
			Else
				Print "-";
			EndIf
		Next Rec
		s = "Press C to clear.          Press Esc to return to main menu."
		Color COLOR_WHITE, 0
		Locate 56, Center_Col(s)
		Print s 
		Keyboard_Clear()
		Do
			Key_Press = UCase(InKey())
		Loop Until Key_Press = KEY_C Or Key_Press = KEY_ESC
		If Key_Press = KEY_C Then
			Locate 23, 21
			Print Space(60)
			s = Space(60)
			Locate 56, Center_Col(s)
			Print s
			For a = 1 To 10
				Locate 23 + (a * 3), 21
				Print Space(60);
			Next a
			s = "Are you sure you want to clear the scores (y/n?)"
			Locate 38, Center_Col(s)
			Print s
			Keyboard_Clear()
			Do
				Key_Press = UCase(InKey())
			Loop Until Len(Key_Press)
			If Key_Press = KEY_Y Then
				For Rec = 1 To 10
					High_Scores(Rec).High_Name = "<EMPTY>             "
					High_Scores(Rec).High_Date = "01/01/1980"
					High_Scores(Rec).High_Level = 0
					High_Scores(Rec).High_Score = 0
				Next Rec	
			EndIf
			Locate 38, 1
			Print Space(100)
		EndIf
	Loop Until Key_Press = KEY_ESC

End Sub
Sub Init_Globals()

	KEY_ENTER = Chr(13)
	KEY_P = "P"
	KEY_F1 = Chr(255, 59)
	KEY_H = "H"
	KEY_ESC = Chr(27)
	KEY_BACKSPACE = Chr(8)
	KEY_ARROW_LEFT = Chr(255, 75)
	KEY_C = "C"
	KEY_Y = "Y"
	
	COLOR_BLUE = RGB(0, 0, 255)
	COLOR_CYAN_LIGHT = RGB(0, 255, 255)
	COLOR_CYAN_DARK = RGB(0, 127, 127)
	COLOR_GREEN = RGB(0, 255, 0)
	COLOR_MAGENTA = RGB(255, 0, 255)
	COLOR_RED = RGB(255, 0, 0)
	COLOR_WHITE = RGB(255, 255, 255)
	COLOR_YELLOW = RGB(255, 255, 0)
	
	AppData_Dir = Environ("APPDATA")

End Sub
Sub Keyboard_Clear()
	
	Do
	Loop While Len(Inkey())
	
End Sub
Sub Level_Complete()
	
	Dim Blocks As UShort
	Dim Bonuses As UByte
	Dim Level_Score As UInteger
	Dim Row As UByte
	Dim a As UByte
	Dim b As UByte
	Dim s As String
	
	For a = 1 To 140
		For b = 1 To 100
			If Maze(a, b) = GRID_PATH_USER Then
				Blocks += 1
			EndIf
		Next b
	Next a
	
	For a = 1 To 5
		If Pellets_Bonus(a).Available = FALSE Then
			Bonuses += 1
		EndIf
	Next a
	
	Cls
	
	Color COLOR_GREEN, 0

	s = "= = =   L E V E L   C O M P L E T E   = = ="
	
	For Row = 1 To 24
		Locate Row, Center_Col(s)
		Print s
	Next Row
	
	For Row = 52 To 75
		Locate Row, Center_Col(s)
		Print s;
	Next Row
	
	Color COLOR_WHITE, 0
	
	s = "Path covered = " & Trim(Str(Blocks)) & " blocks = " & Trim(Str(Blocks * (Level * 5))) & " points."
	Locate 28, Center_Col(s)
	Print s
	s = "Bonuses eaten = " & Trim(Str(Bonuses)) & " = " + Trim(Str(Bonuses * (Level * 1000))) & " points."
	Locate 32, Center_Col(s)
	Print s
	s = "Clean run (no deaths) x2 bonus: "
	If Clean_Run = TRUE Then s = s & "Yes" Else s = s & "No"
	Locate 36, Center_Col(s)
	Print s
	Level_Score = ((Blocks * (Level * 5)) + (Bonuses * (Level * 1000)))
	If Clean_Run = TRUE Then Level_Score *= 2
	s = "Score for this level = " & Trim(Str(Level_Score)) & " points."
	Locate 40, Center_Col(s)
	Print s
	Score += Level_Score
	s = "TOTAL SCORE = " & Trim(Str(Score))
	Color COLOR_RED, 0
	Locate 44, Center_Col(s)
	Print s
	s = "Press Enter to continue..."
	Color COLOR_WHITE, 0
	Locate 48, Center_Col(s)
	Print s
	Keyboard_Clear()
	Do
	Loop Until InKey() = KEY_ENTER
	
End Sub
Sub Level_Generate()
	
	Dim Start_Side As UByte
	Dim Segment As UByte
	Dim Direction As UByte
	Dim Start_Over As Integer
	Dim Walls As UByte
	Dim Two_By_Two As UShort
	Dim Complexity_Factor As UShort
	Dim a As UByte
	Dim b As UByte
	Dim c As UByte
	Dim x As UShort
	Dim y As UShort
	
	Start_Side = Int(4 * Rnd)
	
	Do
		Start_Over = FALSE
		
		For a = 1 To 140
			For b = 1 To 100
				Maze(a, b) = GRID_WALL
			Next b
		Next a
		
		Select Case Start_Side
			Case SIDE_TOP
				x = Int(138 * Rnd) + 2
				y = 2
				Maze(x, y - 1) = GRID_CORRIDOR
				Start_Row = y - 1
				Start_Col = x
			Case SIDE_RIGHT
				x = 139
				y = Int(98 * Rnd) + 2
				Maze(x + 1, y) = GRID_CORRIDOR
				Start_Row = y
				Start_Col = x + 1
			Case SIDE_BOTTOM
				x = Int(138 * Rnd) + 2
				y = 99
				Maze(x, y + 1) = GRID_CORRIDOR
				Start_Row = y + 1
				Start_Col = x
			Case SIDE_LEFT
				x = 2
				y = (98 * Rnd) + 2
				Maze(x - 1, y) = GRID_CORRIDOR
				Start_Row = y
				Start_Col = x - 1
		End Select
		
		Maze(x, y) = GRID_CORRIDOR
		
		Do
			Direction = Int(4 * Rnd)
			Segment = Int(15 * Rnd) + 1
			For a = 1 To Segment
				Select Case Direction
					Case DIR_UP
						y -= 1
					Case DIR_RIGHT
						x += 1
					Case DIR_DOWN
						y += 1
					Case DIR_LEFT
						x -= 1
				End Select
				Maze(x, y) = GRID_CORRIDOR
				If x >= 2 And x <= 139 And y = 1 And Start_Side = SIDE_BOTTOM Then Exit Do
				If x = 140 And y >= 2 And y <= 98 And Start_Side = SIDE_LEFT Then Exit Do
				If x >= 2 And x <= 139 And y = 100 And Start_Side = SIDE_TOP Then Exit Do
				If x = 1 And y >= 2 And y <= 98 And Start_Side = SIDE_RIGHT Then Exit Do
				If y = 1 Or x = 140 Or y = 100 Or x = 1 Then
					Start_Over = TRUE
					Exit Do
				EndIf
			Next a
		Loop
		
		If Start_Over = FALSE Then
			For a = 1 To 139
				For b = 1 To 99
					Walls = 0
					Walls += Abs(Maze(a, b) = GRID_WALL)
					Walls += Abs(Maze(a + 1, b) = GRID_WALL)
					Walls += Abs(Maze(a, b + 1) = GRID_WALL)
					Walls += Abs(Maze(a + 1, b + 1) = GRID_WALL)
					If Walls = 0 Then Exit For	
				Next b
				If Walls = 0 Then Exit For
			Next a
		EndIf
		
	Loop While Walls = 0 Or Start_Over = TRUE
		
	End_Row = y
	End_Col = x
		
	Complexity_Factor = Int(4001 * Rnd) + 4000	' Lower is more complex

	Do
		x = Int(138 * Rnd) + 2
		y = Int(98 * Rnd) + 2
		Segment = Int(41 * Rnd) + 10 
		Direction = Int(4 * Rnd)
		For a = 1 To Segment
			If Maze(x, y) = GRID_WALL Then Maze(x, y) = GRID_CORRIDOR_TEMP
			Select Case Direction
				Case DIR_UP
					y -= 1
				Case DIR_RIGHT
					x += 1
				Case DIR_DOWN
					y += 1
				Case DIR_LEFT
					x -= 1
			End Select
			If x = 1 Or x = 140 Or y = 1 Or y = 100 Then Exit For
		Next a
		
		For a = 1 To 139
			For b = 1 To 99
				Walls = 0
				Walls += Abs(Maze(a, b) = GRID_WALL)
				Walls += Abs(Maze(a + 1, b) = GRID_WALL)
				Walls += Abs(Maze(a, b + 1) = GRID_WALL)
				Walls += Abs(Maze(a + 1, b + 1) = GRID_WALL)
				If Walls = 0 Then Exit For	
			Next b
			If Walls = 0 Then Exit For
		Next a
		
		If Walls = 0 Then
			For a = 1 To 140
				For b = 1 To 100
					If Maze(a, b) = GRID_CORRIDOR_TEMP Then
						Maze(a, b) = GRID_WALL
					EndIf
				Next b
			Next a
		Else
			For a = 1 To 140
				For b = 1 To 100
					If Maze(a, b) = GRID_CORRIDOR_TEMP Then
						Maze(a, b) = GRID_CORRIDOR
					EndIf
				Next b
			Next a
		EndIf
		
		Two_By_Two = 0
		
		For a = 1 To 139
			For b = 1 To 99
				Walls = 0
				Walls += Abs(Maze(a, b) = GRID_WALL)
				Walls += Abs(Maze(a + 1, b) = GRID_WALL)
				Walls += Abs(Maze(a, b + 1) = GRID_WALL)
				Walls += Abs(Maze(a + 1, b + 1) = GRID_WALL)
				If Walls = 4 Then Two_By_Two = Two_By_Two + 1
			Next b
		Next a
	Loop Until Two_By_Two <= Complexity_Factor
	
	Total_Poison_Pellets = Int(26 * Rnd) + 5
	
	For a = 1 To Total_Poison_Pellets
		Do
			b = Int(140 * Rnd) + 1
			c = Int(100 * Rnd) + 1
		Loop While Maze(b, c) = GRID_WALL Or (b = Start_Col And c = Start_Row)
		Pellets_Poison(a).Row = c
		Pellets_Poison(a).Col = b
	Next a
	
	For a = 1 To 5
		Do
			b = Int(140 * Rnd) + 1
			c = Int(100 * Rnd) + 1
		Loop While Maze(b, c) = GRID_WALL Or (b = Start_Col And c = Start_Row)
		Pellets_Bonus(a).Row = c
		Pellets_Bonus(a).Col = b
		Pellets_Bonus(a).Available = TRUE
	Next a

End Sub
Sub Level_Play()
	
	Dim Row As UByte
	Dim Col As UByte
	Dim Old_Row As UByte
	Dim Old_Col As UByte
	Dim Draw_New_Loc As Integer
	Dim Start_Time_Level As Double
	Dim Start_Time_Sync As Double
	Dim Clock_Min As String
	Dim Clock_Sec As String
	Dim a As UByte
	Dim b As UByte
	Dim x As UShort
	Dim y As UShort
	Dim s As String
	
	Cls

	For b = 1 To 100
		For a = 1 To 140
			x = (a - 1) * 5 + 50
			y = (b - 1) * 5 + 50
			If Maze(a, b) = GRID_WALL Then
				Line(x, y) - (x + 4, y + 4), COLOR_CYAN_DARK, BF
			Else
				Line(x, y) - (x + 4, y + 4), 0, BF
			EndIf
		Next a
	Next b
	
	x = (Start_Col - 1) * 5 + 50 + 2
	y = (Start_Row - 1) * 5 + 50 + 2
	
	If x = 52 Then
		Line (x - 10, y - 7) - (x - 3, y), COLOR_GREEN
		Line (x - 3, y) - (x - 10, y + 7), COLOR_GREEN
		Line (x - 30, y) - (x - 3, y), COLOR_GREEN
	ElseIf x = 747 Then
		Line (x + 10, y - 7) - (x + 3, y), COLOR_GREEN
		Line (x + 3, y) - (x + 10, y + 7), COLOR_GREEN
		Line (x + 30, y) - (x + 3, y), COLOR_GREEN
	ElseIf y = 52 Then
		Line (x - 7, y - 10) - (x, y - 3), COLOR_GREEN
		Line (x, y - 3) - (x + 7, y - 10), COLOR_GREEN
		Line (x, y - 30) - (x, y - 3), COLOR_GREEN
	ElseIf y = 547 Then
		Line (x - 7, y + 10) - (x, y + 3), COLOR_GREEN
		Line (x, y + 3) - (x + 7, y + 10), COLOR_GREEN
		Line (x, y + 30) - (x, y + 3), COLOR_GREEN
	EndIf

	x = (End_Col - 1) * 5 + 50 + 2
	y = (End_Row - 1) * 5 + 50 + 2
	
	If x = 52 Then
		Line (x - 10, y - 7) - (x - 3, y), COLOR_RED
		Line (x - 3, y) - (x - 10, y + 7), COLOR_RED
		Line (x - 30, y) - (x - 3, y), COLOR_RED
	ElseIf x = 747 Then
		Line (x + 10, y - 7) - (x + 3, y), COLOR_RED
		Line (x + 3, y) - (x + 10, y + 7), COLOR_RED
		Line (x + 30, y) - (x + 3, y), COLOR_RED
	ElseIf y = 52 Then
		Line (x - 7, y - 10) - (x, y - 3), COLOR_RED
		Line (x, y - 3) - (x + 7, y - 10), COLOR_RED
		Line (x, y - 30) - (x, y - 3), COLOR_RED
	ElseIf y = 547 Then
		Line (x - 7, y + 10) - (x, y + 3), COLOR_RED
		Line (x, y + 3) - (x + 7, y + 10), COLOR_RED
		Line (x, y + 30) - (x, y + 3), COLOR_RED
	EndIf

	Row = Start_Row
	Col = Start_Col
	Finished = FALSE
	Died = FALSE
	Draw_New_Loc = TRUE
	Start_Time_Level = Timer
	Start_Time_Sync = Timer
	
	Do
		If Draw_New_Loc = TRUE Then
			x = (Col - 1) * 5 + 50
			y = (Row - 1) * 5 + 50
			Line(x, y) - (x + 4, y + 4), COLOR_GREEN, BF
			Line(x + 1, y + 1) - (x + 3, y + 3), 0, BF
			Maze(Col, Row) = GRID_PATH_USER
			Draw_New_Loc = FALSE
		EndIf
		If Row = End_Row And Col = End_Col Then Finished = TRUE
		Pellets_Collision_Test()
		If Timer - Start_Time_Level >= 300 Then
			Died = TRUE
			Lives -= 1
			Clean_Run = FALSE
		EndIf
		If Finished = FALSE And Died = FALSE Then
			If Timer - Start_Time_Sync >= .100 Then
				Old_Row = Row
				Old_Col = Col
				If MultiKey(FB.SC_LEFT) Then
					Col -= 1
				ElseIf MultiKey(FB.SC_RIGHT) Then
					Col += 1
				EndIf
				If Col = Old_Col Then
					If MultiKey(FB.SC_UP) Then
						Row -= 1
					ElseIf MultiKey(FB.SC_DOWN) Then
						Row += 1
					EndIf
				EndIf
				If Maze(Col, Row) = GRID_WALL Then
					Row = Old_Row
					Col = Old_Col
				Else
					x = (Old_Col - 1) * 5 + 50
					y = (Old_Row - 1) * 5 + 50
					Line(x + 1, y + 1) - (x + 3, y + 3), COLOR_GREEN, BF
					Draw_New_Loc = TRUE
				EndIf
				Pellets_Move()
				Start_Time_Sync = Timer
			EndIf
			If Row = 0 Or Col = 0 Or Row = 101 Or Col = 141 Then
				Row = Old_Row
				Col = Old_Col
			EndIf
		EndIf
		Clock_Min = Trim(Str(Int(300 - (Timer - Start_Time_Level)) \ 60))
		Clock_Sec = Trim(Str(Int(300 - (Timer - Start_Time_Level)) Mod 60))
		If Val(Clock_Sec) < 10 Then Clock_Sec = "0" & Clock_Sec
		s = Clock_Min & " : " & Clock_Sec
		Color COLOR_WHITE, 0
		Locate 74, Center_Col(s)
		Print s
		If MultiKey(FB.SC_ESCAPE) Then Quit_Game = TRUE
		If MultiKey(FB.SC_P) Then Sleep
	Loop Until Finished = TRUE Or Died = TRUE Or Quit_Game = TRUE
	
	Keyboard_Clear()

End Sub
Sub Level_Up()
	
	Dim Row As UByte
	Dim r As UByte
	Dim g As UByte
	Dim b As UByte
	Dim s As String
	
	Cls
	
	Level += 1
	Clean_Run = TRUE
	
	s = "= = =   L E V E L   " & Trim(Str(Level)) & "   = = ="

	For Row = 1 To 32
		r = Int(206 * Rnd) + 50
		g = Int(206 * Rnd) + 50
		b = Int(206 * Rnd) + 50
		Color RGB(r, g, b), 0
		Locate Row, Center_Col(s)
		Print s
	Next Row
	
	For Row = 44 To 75
		r = Int(206 * Rnd) + 50
		g = Int(206 * Rnd) + 50
		b = Int(206 * Rnd) + 50
		Color RGB(r, g, b), 0
		Locate Row, Center_Col(s)
		Print s;
	Next Row

	Color COLOR_WHITE, 0

	s = "Please wait, generating maze..."
	Locate 36, Center_Col(s)
	Print s
	Level_Generate()
	s = "Press Enter to continue..."
	Locate 40, Center_Col(s)
	Print s

	Keyboard_Clear()

	Do
	Loop Until InKey() = KEY_ENTER
	
End Sub
Sub Pellets_Collision_Test

	Dim a As UByte
	Dim x As UShort
	Dim y As UShort
	
	For a = 1 To Total_Poison_Pellets
		If Maze(Pellets_Poison(a).Col, Pellets_Poison(a).Row) = GRID_PATH_USER Then
			Died = TRUE
			Lives -= 1
			Clean_Run = FALSE
			Exit For
		EndIf
	Next a
	
	For a = 1 To 5
		If Pellets_Bonus(a).Available = TRUE Then
			If Maze(Pellets_Bonus(a).Col, Pellets_Bonus(a).Row) = GRID_PATH_USER Then
				Pellets_Bonus(a).Available = FALSE
				x = (Pellets_Bonus(a).Col - 1) * 5 + 50
				y = (Pellets_Bonus(a).Row - 1) * 5 + 50
				Line(x, y) - (x + 4, y + 4), COLOR_GREEN, BF
			EndIf
		EndIf
	Next a
	
End Sub
Sub Pellets_Move()

	Dim Direction As UByte
	Dim Old_Row As UByte
	Dim Old_Col As UByte
	Dim a As UByte
	Dim x As UShort
	Dim y As UShort
	
	For a = 1 To Total_Poison_Pellets
		Old_Row = Pellets_Poison(a).Row
		Old_Col = Pellets_Poison(a).Col
		Direction = Int(4 * Rnd)
		Select Case Direction
			Case DIR_UP
				Pellets_Poison(a).Row -= 1
			Case DIR_DOWN
				Pellets_Poison(a).Row += 1
			Case DIR_LEFT
				Pellets_Poison(a).Col -= 1
			Case DIR_RIGHT
				Pellets_Poison(a).Col += 1
		End Select
		If Maze(Pellets_Poison(a).Col, Pellets_Poison(a).Row) = GRID_WALL Then
			Pellets_Poison(a).Row = Old_Row
			Pellets_Poison(a).Col = Old_Col
		EndIf
		If Pellets_Poison(a).Row = 0 Or Pellets_Poison(a).Row = 101 Then
			Pellets_Poison(a).Row = Old_Row
			Pellets_Poison(a).Col = Old_Col
		EndIf
		If Pellets_Poison(a).Col = 0 Or Pellets_Poison(a).Col = 141 Then
			Pellets_Poison(a).Row = Old_Row
			Pellets_Poison(a).Col = Old_Col
		EndIf
		If Pellets_Poison(a).Row <> Old_Row Or Pellets_Poison(a).Col <> Old_Col Then
			x = (Old_Col - 1) * 5 + 50
			y = (Old_Row - 1) * 5 + 50
			Line(x, y) - (x + 4, y + 4), 0, BF
			x = (Pellets_Poison(a).Col - 1) * 5 + 50
			y = (Pellets_Poison(a).Row - 1) * 5 + 50
			Line(x, y) - (x + 4, y + 4), COLOR_RED, BF
		EndIf
	Next a

	For a = 1 To 5
		If Pellets_Bonus(a).Available = TRUE Then
			Old_Row = Pellets_Bonus(a).Row
			Old_Col = Pellets_Bonus(a).Col
			Direction = Int(4 * Rnd)
			Select Case Direction
				Case DIR_UP
					Pellets_Bonus(a).Row -= 1
				Case DIR_DOWN
					Pellets_Bonus(a).Row += 1
				Case DIR_LEFT
					Pellets_Bonus(a).Col -= 1
				Case DIR_RIGHT
					Pellets_Bonus(a).Col += 1
			End Select
			If Maze(Pellets_Bonus(a).Col, Pellets_Bonus(a).Row) = GRID_WALL Then
				Pellets_Bonus(a).Row = Old_Row
				Pellets_Bonus(a).Col = Old_Col
			EndIf
			If Pellets_Bonus(a).Row = 0 Or Pellets_Bonus(a).Row = 101 Then
				Pellets_Bonus(a).Row = Old_Row
				Pellets_Bonus(a).Col = Old_Col
			EndIf
			If Pellets_Bonus(a).Col = 0 Or Pellets_Bonus(a).Col = 141 Then
				Pellets_Bonus(a).Row = Old_Row
				Pellets_Bonus(a).Col = Old_Col
			EndIf
			If Pellets_Bonus(a).Row <> Old_Row Or Pellets_Bonus(a).Col <> Old_Col Then
				x = (Old_Col - 1) * 5 + 50
				y = (Old_Row - 1) * 5 + 50
				Line(x, y) - (x + 4, y + 4), 0, BF
				x = (Pellets_Bonus(a).Col - 1) * 5 + 50
				y = (Pellets_Bonus(a).Row - 1) * 5 + 50
				Line(x, y) - (x + 4, y + 4), COLOR_YELLOW, BF
			EndIf
		EndIf
	Next a
	
End Sub
Sub Play_Game()
	
	Score = 0
	Level = 0
	Lives = 10
	Died = FALSE
	Finished = FALSE
	Quit_Game = FALSE
	
	Do
		If Died = FALSE Then Level_Up()
		Level_Play()
		If Finished = TRUE And Quit_Game = FALSE Then
			Level_Complete()
		ElseIf Died = TRUE And Lives >= 1 And Finished = FALSE And Quit_Game = FALSE Then
			Player_Die()
		EndIf
	Loop Until Lives = 0 Or Quit_Game = TRUE
		
	If Quit_Game = FALSE Then Game_Over()
	
End Sub
Sub Player_Die()
	
	Dim Row As ubyte
	Dim s As String
	
	Cls

	s = "= = =   Y O U   D I E D !   = = ="

	Color COLOR_RED, 0

	For Row = 1 To 30
		Locate Row, Center_Col(s)
		Print s
	Next Row

	For Row = 46 To 75
		Locate Row, Center_Col(s)
		Print s;
	Next Row
	
	If Lives > 1 Then
		s = "You have " & Trim(Str(Lives)) & " lives remaining."
	Else
		s = "You have one life left."
	EndIf

	Color COLOR_WHITE, 0
	Locate 34, Center_Col(s)
	Print s
	
	s = "Please wait, generating maze..."
	Locate 38, Center_Col(s)
	Print s
	Level_Generate()
	s = "Press Enter to continue..."
	Locate 42, Center_Col(s)
	Print s

	Keyboard_Clear()

	Do
	Loop Until InKey() = KEY_ENTER
	
End Sub
Sub Program_Begin()

	Randomize Timer
	Init_Globals()
	High_Scores_Load()

	If Instr(UCase(Command), "/W") Then
		ScreenRes 800, 600, 32, 1, &H00
	Else
		ScreenRes 800, 600, 32, 1, &H01
	EndIf

	Window_Set_Icon()	
	SetMouse , , FALSE
		
End Sub
Sub Program_Main()

	Dim Key_Press As String

	Draw_Title_Screen()
	
	Do
		Do
			Key_Press = UCase(InKey)
		Loop While Len(Key_Press) = 0
		Select Case Key_Press
			Case KEY_ENTER
				Play_Game()			
				Draw_Title_Screen()
			Case KEY_F1
				Help()
				Draw_Title_Screen()
			Case KEY_H
				High_Scores_View()
				Draw_Title_Screen()
		End Select
	Loop Until Key_Press = KEY_ESC

End Sub
Sub Window_Set_Icon()
	
	Dim fbgfx_hWnd As hWnd
	Dim fbgfx_hIcon as hIcon

	ScreenControl(FB.GET_WINDOW_HANDLE, Cast(Integer, fbgfx_hWnd))
	fbgfx_hIcon = LoadImage(GetModuleHandle(NULL), MAKEINTRESOURCE(101), IMAGE_ICON, 0, 0, NULL)
	SendMessage(fbgfx_hWnd, WM_SETICON, ICON_SMALL, Cast(Integer, fbgfx_hIcon))
	
	' If loading the icon from a file, use:
	'
	' SendMessage(fbgfxHwnd, WM_SETICON, ICON_SMALL, LoadImage(NULL, "Icon_16x16.ico", IMAGE_ICON, 16, 16, LR_LOADFROMFILE))
	
End Sub
