declare sub data_MAP_read()
declare sub data_MAP_write()
declare sub data_CSV_read()
declare sub data_CSV_write()
declare sub data_SAVE_read()
declare sub data_SAVE_write()
declare sub data_SAVE_MAP_read()
declare sub data_SAVE_MAP_write()
declare sub data_CFG_read()
declare sub data_CFG_write()
declare sub feedback_url()

'-------------------------------------------------------------------------------
sub data_MAP_read()
    
    dim as ubyte fn_x, fn_y
    
    chdir("MAP")
    
    'create a new map in the editor if there is none
    file_map(world_x,world_y)=freefile
    if open(file_map_path(world_x,world_y) for input as #file_map(world_x,world_y)) = 2 then
        if engine = 31 then
            x_max = i_mms
            y_max = i_mms
            map_type = 1
            'erase all old data
            for fn_x = 1 to i_mms
                for fn_y = 1 to i_mms
                    map(fn_x,fn_y) = 0
                next
            next
            'write empty map
            chdir("..")
            data_MAP_write()
            chdir("MAP")
        endif
    endif
    
    'check for more read errors
    file_map(world_x,world_y)=freefile
    if open(file_map_path(world_x,world_y) for input as #file_map(world_x,world_y)) > 0 then
        inc():print(error_read+file_map_path(world_x,world_y)):sleep 3000,1:end
    endif
    
    'read map data
    file_map(world_x,world_y)=freefile
    open file_map_path(world_x,world_y) for input as #file_map(world_x,world_y)
        'read map properties
        input #file_map(world_x,world_y), x_max, y_max, map_type
        'read map data
        for fn_x = 1 to x_max
            for fn_y = 1 to y_max
                input #file_map(world_x,world_y), map(fn_x,fn_y)
                'prevent from loading false data
                if map(fn_x,fn_y) > i_mos then
                    map(fn_x,fn_y) = 0
                endif
            next
        next
    close
    
    chdir("..")
    
    'erase old en_hp data
    for fn_x = 1 to i_mms
        for fn_y = 1 to i_mms
            en_hp(fn_x,fn_y) = 0
        next
    next
    
end sub

'-------------------------------------------------------------------------------
sub data_MAP_write()
    
    dim as ubyte fn_x, fn_y
    
    chdir("MAP")
    
    'check for write errors
    file_map(world_x,world_y)=freefile
    if open(file_map_path(world_x,world_y) for output as #file_map(world_x,world_y)) > 0 then
        inc():print(error_write+file_map_path(world_x,world_y) ):sleep 3000,1:end
    endif
    
    'erase old file
    kill file_map_path(world_x,world_y)
    
    'write map data
    file_map(world_x,world_y)=freefile
    open file_map_path(world_x,world_y) for output as #file_map(world_x,world_y)
        'write map properties
        write #file_map(world_x,world_y), x_max, y_max, map_type
        'write map data
        for fn_x = 1 to x_max
            for fn_y = 1 to y_max
                write #file_map(world_x,world_y), map(fn_x,fn_y)
            next
        next
    close
    
    chdir("..")
    
end sub

'-------------------------------------------------------------------------------
sub data_CSV_read()
    
    dim as ushort id, file_counter
    
    chdir("DAT")
    
    'check for read errors
    file_gamedata=freefile
    if open(file_gamedata_path for input as #file_gamedata) > 0 then
        inc():print(error_read+file_gamedata_path):sleep 3000,1:end
    endif
    
    
    
    
    'read gamedata
    file_gamedata=freefile
    open file_gamedata_path for input as #file_gamedata
        do until eof(file_gamedata)
            input #file_gamedata, _
                id
                
            data_id(id)=id
            
            input #file_gamedata, _                
                data_type       (id), _
                data_names      (id), _
                data_image      (id), _
                data_image_type (id), _
                data_active     (id), _
                data_post       (id), _
                data_block      (id), _
                data_value_1    (id), _
                data_value_2    (id), _
                data_value_3    (id), _
                data_value_4    (id), _
                data_value_5    (id), _
                data_value_6    (id), _
                data_wait       (id), _
                data_sfx        (id), _
                data_spirit     (id)
        loop
    close
    
    'check for read errors
    file_strings=freefile
    if open(file_strings_path for input as #file_strings) > 0 then
        print(error_read+file_strings_path):sleep 3000,1:end
    endif
    
    'read strings
    file_strings=freefile
    open file_strings_path for input as #file_strings
        do until eof(file_strings)
            file_counter = file_counter + 1
            input #file_strings, _
                data_strings(file_counter)
        loop
        file_counter = 0
    close
    
    chdir("..")
    
end sub

'-------------------------------------------------------------------------------
sub data_CSV_write()
    
    dim as ushort id, file_counter
    
    chdir("DAT")
    
    'check for write errors
    file_gamedata=freefile
    if open(file_gamedata_path for output as #file_gamedata) > 0 then
        inc():print(error_write+file_gamedata_path):sleep 3000,1:end
    endif
    
    'erase old file
    kill file_gamedata_path
    
    'write gamedata
    file_gamedata=freefile
    open file_gamedata_path for output as #file_gamedata
        do
            
            id = id + 1
            
            if data_id(id) <> 0 then
            
            write #file_gamedata, _
                data_id         (id), _
                data_type       (id), _
                data_names      (id), _
                data_image      (id), _
                data_image_type (id), _
                data_active     (id), _
                data_post       (id), _
                data_block      (id), _
                data_value_1    (id), _
                data_value_2    (id), _
                data_value_3    (id), _
                data_value_4    (id), _
                data_value_5    (id), _
                data_value_6    (id), _
                data_wait       (id), _
                data_sfx        (id), _
                data_spirit     (id)
            endif
        loop until id = i_mos
    close
    
    
    
    
    
    chdir("..")
    
end sub

'-------------------------------------------------------------------------------
sub data_SAVE_read()
    
    chdir("Save")
    
    'check for read errors
    file_save=freefile
    if open(file_save_path for input as #file_save) > 0 then
        inc():print(error_read+file_save_path):sleep 3000,1:end
    endif
    
    
    
    
    'read save game
    file_save=freefile
    open file_save_path for input as #file_save
        'states
        input #file_save, _
            x, y, x_old, y_old, world_x, world_y, pl_view, _
            pl_hp, pl_hp_max, pl_ma, pl_ma_max, _
            pl_hu, pl_hu_max, pl_hu_drain ,pl_th, pl_th_max, pl_th_drain, _
            pl_xp, pl_xp_max, pl_str, pl_dex, pl_def, pl_level, _
            pl_fire ,pl_ice ,pl_money, _
            itm_sel, itm_x, itm_y, _
            pause, auto_play, pl_move, draw_msg, draw_mini_map, draw_compass, _
            fight_round, fight_anim, pl_atk, en_atk, ani_en_move, choice, _
            rnd_floor, pl_ma_load
            
        'items
        dim as ubyte fn_x, fn_y
        for fn_x = 1 to itm_x_max
            for fn_y = 1 to itm_y_max
                input #file_save, itm(fn_x,fn_y)
            next
        next
        
        'mini maps
        for fn_x = 1 to world_x
            for fn_y = 1 to world_y
                input #file_save, mini_map(fn_x,fn_y)
            next
        next
    close
    
    chdir("..")
    
end sub

'-------------------------------------------------------------------------------
sub data_SAVE_write()
    
    chdir("Save")
    
    'check for write errors
    file_save=freefile
    if open(file_save_path for output as #file_save) > 0 then
        inc():print(error_write+file_save_path):sleep 3000,1:end
    endif
    
    'erase old file
    kill file_save_path
    
    'write save game
    file_save=freefile
    open file_save_path for output as #file_save
        'states
        write #file_save, _
            x, y, x_old, y_old, world_x, world_y, pl_view, _
            pl_hp, pl_hp_max, pl_ma, pl_ma_max, _
            pl_hu, pl_hu_max, pl_hu_drain ,pl_th, pl_th_max, pl_th_drain, _
            pl_xp, pl_xp_max, pl_str, pl_dex, pl_def, pl_level, _
            pl_fire ,pl_ice ,pl_money, _
            itm_sel, itm_x, itm_y, _
            pause, auto_play, pl_move, draw_msg, draw_mini_map, draw_compass, _
            fight_round, fight_anim, pl_atk, en_atk, ani_en_move, choice, _
            rnd_floor, pl_ma_load
            
        'items
        dim as ubyte fn_x, fn_y
        for fn_x = 1 to itm_x_max
            for fn_y = 1 to itm_y_max
                write #file_save, itm(fn_x,fn_y)
            next
        next
        
        'mini maps
        for fn_x = 1 to world_x
            for fn_y = 1 to world_y
                write #file_save, mini_map(fn_x,fn_y)
            next
        next
    close
    
    chdir("..")
    
end sub

'-------------------------------------------------------------------------------
sub data_SAVE_MAP_read()
    
    dim as ubyte fn_x, fn_y
    
    chdir("Save")
    
    'check for read errors
    file_map_save(world_x,world_y)=freefile
    if open(file_map_save_path(world_x,world_y) for input as #file_map_save(world_x,world_y)) > 0 then
        inc():print(error_read+file_map_save_path(world_x,world_y)):sleep 3000,1:end
    endif
    
    
    
    
    'read savegame
    file_map_save(world_x,world_y)=freefile
    open file_map_save_path(world_x,world_y) for input as #file_map_save(world_x,world_y)
        'read map properties
        input #file_map_save(world_x,world_y), x_max, y_max, map_type
        'read map data
        for fn_x = 1 to x_max
            for fn_y = 1 to y_max
                input #file_map_save(world_x,world_y), map(fn_x,fn_y)
            next
        next
    close
    
    'check for read errors
    file_en_hp_save(world_x,world_y)=freefile
    if open(file_en_hp_save_path(world_x,world_y) for input as #file_en_hp_save(world_x,world_y)) > 0 then
        inc():print(error_read+file_en_hp_save_path(world_x,world_y)):sleep 3000,1:end
    endif
    
    
    
    
    'read en_hp
    file_en_hp_save(world_x,world_y)=freefile
    open file_en_hp_save_path(world_x,world_y) for input as #file_en_hp_save(world_x,world_y)
        for fn_x = 1 to x_max
            for fn_y = 1 to y_max
                input #file_en_hp_save(world_x,world_y), en_hp(fn_x,fn_y)
            next
        next
    close
    
    chdir("..")
    
end sub

'-------------------------------------------------------------------------------
sub data_SAVE_MAP_write()
    
    dim as ubyte fn_x, fn_y
    
    chdir("Save")
    
    'check for write errors
    file_map_save(world_x,world_y)=freefile
    if open(file_map_save_path(world_x,world_y) for output as #file_map_save(world_x,world_y)) > 0 then
        inc():print(error_write+file_map_save_path(world_x,world_y)):sleep 3000,1:end
    endif
    
    'erase old file
    kill file_map_save_path(world_x,world_y)
    
    'write savegame
    file_map_save(world_x,world_y)=freefile
    open file_map_save_path(world_x,world_y) for output as #file_map_save(world_x,world_y)
        'write map properties
        write #file_map_save(world_x,world_y), x_max, y_max, map_type
        'write map data
        for fn_x = 1 to x_max
            for fn_y = 1 to y_max
                write #file_map_save(world_x,world_y), map(fn_x,fn_y)
            next
        next
    close
        
    'check for write errors
    file_en_hp_save(world_x,world_y)=freefile
    if open(file_en_hp_save_path(world_x,world_y) for output as #file_en_hp_save(world_x,world_y)) > 0 then
        inc():print(error_write+file_en_hp_save_path(world_x,world_y)):sleep 3000,1:end
    endif
    
    'erase old file
    kill file_en_hp_save_path(world_x,world_y)
    
    'write en_hp
    file_en_hp_save(world_x,world_y)=freefile
    open file_en_hp_save_path(world_x,world_y) for output as #file_en_hp_save(world_x,world_y)
        for fn_x = 1 to x_max
            for fn_y = 1 to y_max
                write #file_en_hp_save(world_x,world_y), en_hp(fn_x,fn_y)
            next
        next
    close
    
    chdir("..")
    
end sub

'-------------------------------------------------------------------------------
sub data_CFG_read()
    
    'if there is no file create one
    file_cfg=freefile
    if open(file_cfg_path for input as #file_cfg) = 2 then
        data_CFG_write()
    endif
    
    'check for more read errors
    file_cfg=freefile
    if open(file_cfg_path for input as #file_cfg) > 0 then
        inc():print(error_read):sleep 3000,1:end
    endif
    
    'read cfg
    file_cfg=freefile
    open file_cfg_path for input as #file_cfg
        input #file_cfg, _
            sc_full, sc_intro, sc_filter, sc_driver, feedback
    close
    
end sub

'-------------------------------------------------------------------------------
sub data_CFG_write()
    
    'check for write errors
    file_cfg=freefile
    if open(file_cfg_path for output as #file_cfg) > 0 then
        inc():print(error_write):sleep 3000,1:end
    endif
    
    'erase old file
    kill file_cfg_path
    
    'write cfg
    file_cfg=freefile
    open file_cfg_path for output as #file_cfg
        write #file_cfg, _
            sc_full, sc_intro, sc_filter, sc_driver, feedback
    close
    
end sub

'-------------------------------------------------------------------------------
sub feedback_url()
    
    if feedback then
        feedback = 0
        data_CFG_write()
        shell "start http://catbone.freebasic.net/feedback/"
    endif
    
end sub
