declare sub math_menu()
declare sub math_map3d()
declare sub math_map2d()
declare sub math_bag()
declare sub math_editor_loadmap()
declare sub math_editor()
declare sub math_object_editor()
declare sub map_events()
declare sub draw_map3d()'need to be declared here
declare sub draw_map2d()

'-------------------------------------------------------------------------------
sub math_menu()
    
    'bug preventing - menu cursor postition
    if i_menu_cur_pos < 0 then i_menu_cur_pos = 0
    select case as const i_menu
    case 0:if i_menu_cur_pos > 2 then i_menu_cur_pos = 2'main
    case 1:if i_menu_cur_pos > 3 then i_menu_cur_pos = 3'start
    case 2:if i_menu_cur_pos > 2 then i_menu_cur_pos = 2'options
    end select
    
    if key_enter = true then
        select case as const i_menu
        case 0'main
            select case as const i_menu_cur_pos
            case 0'sub menu game
                i_menu = 1
                i_menu_cur_pos = 0
            case 1'sub menu options
                i_menu = 2
                i_menu_cur_pos = 0
            case 2'quit game
                engine = 0
                pause = 0'bug preventing
            end select
        case 1'game
            select case as const i_menu_cur_pos
            case 0'new game
                engine = 10
                stopstr(str_menu)
                chdir("MOV")
                    playmov("intro",838,100)
                chdir("..")
                #include once "math/newgame.bas"
                data_CSV_read()
                data_MAP_read()
                flush()
            case 1'load game
                chdir("Save")
                file_save=freefile
                if open(file_save_path for input as #file_save) = 0 then
                    close
                    chdir("..")
                    engine = 10
                    stopstr(str_menu)
                    data_CSV_read()
                    data_SAVE_read()
                    data_SAVE_MAP_read()
                    flush()
                else
                    close
                    chdir("..")
                endif
            case 2'save game
                if world_x <> 0 then
                    engine = 10
                    data_SAVE_write()
                    data_SAVE_MAP_write()
                endif
            case 3'continue game
                if world_x <> 0 then
                    engine = 10
                endif
            end select
        case 2'options
            select case as const i_menu_cur_pos
            case 0'map editor
                pausstr()
                initscreen(1)
                engine = 30
                ed_sel_tile = ed_sel_tile
            case 1'fullscreen
                if sc_full = 0 then
                    sc_full = 1
                elseif sc_full = 1 then
                    sc_full = 0
                endif
                initscreen()
                data_CFG_write()
                flush()
            case 2'scale
                sc_filter = sc_filter + 1
                if sc_filter > 4 then sc_filter = 1
                initscreen()
                data_CFG_write()
                flush()
            end select
        end select
    endif
    
end sub

'-------------------------------------------------------------------------------
sub math_map3d()
    
    'player view
    if pl_view > 4 then pl_view = 1
    if pl_view < 1 then pl_view = 4
    
    'moving and blocking
    if pl_move > 0 then
        'set position to return to
        if data_block(map(x,y)) <> 2 then
            x_old = x
            y_old = y
        endif
    endif
    if pl_move = 1 then'move forward
        if data_block(map(x,y)) <> 2 then'block
            select case as const pl_view
            case 1:y = y - 1
            case 2:x = x + 1
            case 3:y = y + 1
            case 4:x = x - 1
            end select
        elseif data_block(map(x,y)) = 2 then'go to the old position if there is a hinder
            x = x_old
            y = y_old
        endif
    elseif pl_move = 2 then'move backward
        if data_block(map(x,y)) <> 2 then'block
            select case as const pl_view
            case 1:y = y + 1
            case 2:x = x - 1
            case 3:y = y - 1
            case 4:x = x + 1
            end select
        elseif data_block(map(x,y)) = 2 then'go to the old position if there is a hinder
            x = x_old
            y = y_old
        endif
    endif
    
    'make tiles look random
    if pl_move = 1 or pl_move = 2 or key_left or key_right then
        if rnd_floor = 1 then
            rnd_floor = 0
        elseif rnd_floor = 0 then
            rnd_floor = 1
        endif
    endif
    pl_move = 0
    
    'put enemies hp in extra array
    if data_type(map(x,y)) = 9 and en_hp(x,y) = 0 then
        en_hp(x,y) = data_value_1(map(x,y))
    endif
    
    'events
    if key_enter = true or _'or if hit enter
    data_active(map(x,y)) = 1 or _'or if auto activate
    auto_play = true then'or if animation
        if data_spirit(map(x,y)) = 0 or data_spirit(map(x,y)) = 1 then'human activation
            map_events()
        endif
        'digg
        if itm(11,2) = 80 then
            select case as const pl_view
            case 1:if map(x,y-1) = 6 then map(x,y-1) = 5:playsnd(snd_fx(13))
            case 2:if map(x+1,y) = 6 then map(x+1,y) = 5:playsnd(snd_fx(13))
            case 3:if map(x,y+1) = 6 then map(x,y+1) = 5:playsnd(snd_fx(13))
            case 4:if map(x-1,y) = 6 then map(x-1,y) = 5:playsnd(snd_fx(13))
            end select
        endif
    endif
    
    'stop auto play if you run from fight
    if data_type(map(x,y)) <> 9 then
        fight_round = 0
        fight_anim = 0
        auto_play = false
    endif
    
    'set animation speed
    if fight_round = 0 then
        speed = speed_def
    elseif fight_round > 0 then
        speed = 300
    endif
    
    'level up
    level_up()
    
    'mini map
    if key_delete and mini_map(world_x,world_y) = 1 then
        if draw_mini_map = false then
            draw_mini_map = true
        elseif draw_mini_map = true then
            draw_mini_map = false
        endif
    endif
    
    'drain hunger and thirst
    if key_down=true or key_up=true or key_left=true or key_right=true then
        if pl_hu > 0 then
            pl_hu = pl_hu - pl_hu_drain
        else'drain life when too hungry
            pl_hp = pl_hp -1
            playsnd(snd_fight_pain)
        endif
        if pl_th > 0 then
            pl_th = pl_th - pl_th_drain
        else'drain life when too thirsty
            pl_hp = pl_hp -1
            playsnd(snd_fight_pain)
        endif
    endif
    
    'bug prevention - states
    if pl_hp > pl_hp_max then pl_hp = pl_hp_max
    if pl_hp < 1 then pl_hp = 0
    if pl_ma > pl_ma_max then pl_ma = pl_ma_max
    if pl_ma < 1 then pl_ma = 0
    if pl_hu > pl_hu_max then pl_hu = pl_hu_max
    if pl_hu < 1 then pl_hu = 0
    if pl_th > pl_th_max then pl_th = pl_th_max
    if pl_th < 1 then pl_th = 0
    if pl_money > 99999 then pl_money = 99999
    if pl_money < 0 then pl_money = 0
    
    'death
    if pl_hp <= 0 then
        engine = 20
        playsnd(snd_death)
    endif
    
end sub

'-------------------------------------------------------------------------------
sub math_map2d()
    
    'walk through walls
    if data_block(map(x,y)) = 1 then
        'block if there is no mana left and prevent from walking too deep
        if pl_ma < 10 or data_block(map(x+1,y)) + data_block(map(x-1,y)) + data_block(map(x,y+1)) + data_block(map(x,y-1)) > 2 then
            if key_down = true then
                y = y - 1
            elseif key_up = true then
                y = y + 1
            elseif key_left = true then
                x = x + 1
            elseif key_right = true then
                x = x - 1
            endif
        'drain mana while walking through walls
        elseif key_down=true or key_up=true or key_left=true or key_right=true then
            pl_ma = pl_ma - 20
        endif
    endif
    
    'events
    if key_enter = true or _'or if hit enter
    data_active(map(x,y)) = 1 or _'if auto activate
    auto_play = true then'or if animation
        if data_spirit(map(x,y)) = 1 or data_spirit(map(x,y)) = 2 or data_spirit(map(x,y)) = 3 then'spirit activation
            map_events()
        endif
    endif
    
    'level up
    level_up()
    
    'rechage mana
    pl_ma_load = pl_ma_load + 1
    if pl_ma_load = 70 then
        pl_ma = pl_ma + 1
        pl_ma_load = 0
    endif
    
    'bug prevention - states
    if pl_ma > pl_ma_max then pl_ma = pl_ma_max
    if pl_ma < 1 then pl_ma = 0
    
    'live
    if pl_hp > 0 then
        engine = 10
        if pl_hu <= 0 then pl_hu = 400
        if pl_th <= 0 then pl_th = 400
    endif
    
end sub

'-------------------------------------------------------------------------------
sub math_bag()
    
    'cursor x - prevent from moving outside the box
    if itm_x < 1 then
        itm_x = itm_x_max
    elseif itm_x > itm_x_max then
        itm_x = 1
    endif
    
    'cursor y - prevent from moving outside the box
    if itm_y < 1 then
        itm_y = itm_y_max
    elseif itm_y > itm_y_max then
        itm_y = 1
    endif
    
    'action item
    if key_enter = true then
        
        'put items on body
        if itm_x >= 11 and itm_y >= 1 and itm_y <= 4 then
            
            'change status - take points
            if data_value_1(itm(itm_x,itm_y)) = 1 then'weapon
                pl_str = pl_str - data_value_2(itm(itm_x,itm_y))
            elseif data_value_1(itm(itm_x,itm_y)) >= 2 and data_value_1(itm(itm_x,itm_y)) <=7 then'armor
                pl_def = pl_def - data_value_2(itm(itm_x,itm_y))
            endif
            
            'weapon
            if itm_x = 11 and itm_y = 2 and data_value_1(itm_sel) = 1 then
                switch_items()
            'shield
            elseif itm_x = 13 and itm_y = 2 and data_value_1(itm_sel) = 2 then
                switch_items()
            'armor
            elseif itm_x = 12 and itm_y = 2 and data_value_1(itm_sel) = 3 then
                switch_items()
            'head
            elseif itm_x = 12 and itm_y = 1 and data_value_1(itm_sel) = 4 then
                switch_items()
            'robe
            elseif itm_x = 12 and itm_y = 3 and data_value_1(itm_sel) = 5 then
                switch_items()
            'hands
            elseif itm_x = 11 and itm_y = 3 and data_value_1(itm_sel) = 6 then
                switch_items()
            'feet
            elseif itm_x = 13 and itm_y = 3 and data_value_1(itm_sel) = 7 then
                switch_items()
            'amulet 1
            elseif itm_x = 11 and itm_y = 1 and data_value_1(itm_sel) = 8 then
                switch_items()
            'amulet 2
            elseif itm_x = 13 and itm_y = 1 and data_value_1(itm_sel) = 8 then
                switch_items()
            'rings
            elseif itm_x >= 11 and itm_y = 4 and data_value_1(itm_sel) = 9 then
                switch_items()
            'take bag
            elseif itm_sel = 0 then
                switch_items()
            endif
            
            'change status - put points
            if data_value_1(itm(itm_x,itm_y)) = 1 then'weapon
                pl_str = pl_str + data_value_2(itm(itm_x,itm_y))
            elseif data_value_1(itm(itm_x,itm_y)) >= 2 and data_value_1(itm(itm_x,itm_y)) <=7 then'armor
                pl_def = pl_def + data_value_2(itm(itm_x,itm_y))
            endif
            
        'switch common items
        else
            switch_items()
        endif
        
    endif
    
    'activate item
    if key_space = true then
        
        'if not combine
        if itm_x < 11 or itm_y < 5 then
            'use item
            if data_value_4(itm(itm_x,itm_y)) = 0 or map(x,y) = data_value_4(itm(itm_x,itm_y)) then
                playsnd(snd_fx( data_sfx(itm(itm_x,itm_y)) ))
                'doing a little trick here ;)
                dim as short map_temp
                map_temp = map(x,y)
                    map(x,y) = data_value_6(itm(itm_x,itm_y))
                    map_events()
                map(x,y) = map_temp
                'replace current field
                if data_value_3(itm(itm_x,itm_y)) <> 0 then
                    map(x,y) = data_value_3(itm(itm_x,itm_y))
                endif
                'delete item after use
                if data_value_5(itm(itm_x,itm_y)) = 1 then
                    itm(itm_x,itm_y) = 0
                endif
            endif
        endif
        
        'combine items
        if itm_x >= 11 and itm_y >= 5 then
            dim as ushort fn, fn_x, fn_y, fn_x_b, fn_y_b
            dim as ubyte no_items
            'check formulas
            for fn = 1 to i_mos
            no_items = 0
            if data_type(fn) = 10 then
                'check maximum items
                for fn_x = 11 to itm_x_max
                for fn_y = 5 to itm_y_max
                    if itm(fn_x,fn_y) = 0 then no_items = no_items + 1
                next
                next
                'check item 1
                for fn_x = 11 to itm_x_max
                for fn_y = 5 to itm_y_max
                if itm(fn_x,fn_y) = data_value_1(fn) then
                    'check item 2
                    for fn_x_b = 11 to itm_x_max
                    for fn_y_b = 5 to itm_y_max
                    if itm(fn_x_b,fn_y_b) = data_value_2(fn) then
                        if no_items = 7 then
                            'delete ingredients
                            itm(fn_x,fn_y) = 0
                            itm(fn_x_b,fn_y_b) = 0
                            'put result
                            itm(12,6) = data_value_6(fn)
                            playsnd(snd_combine)
                        endif
                    endif
                    next
                    next
                endif
                next
                next
            endif
            next
        endif
        
    endif
    
    'drop item
    if key_delete = true then
        if map(x,y) = map_type and itm(itm_x,itm_y) > 0 then
            map(x,y) = itm(itm_x,itm_y)
            itm(itm_x,itm_y) = 0
        endif
    endif
    
end sub

'-------------------------------------------------------------------------------
sub math_editor_loadmap()
    
    'stop on borders
    if ed_pos_x < 25-i_mws then ed_pos_x = 25-i_mws
    if ed_pos_y < 18-i_mws then ed_pos_y = 18-i_mws
    if ed_pos_x > 0 then ed_pos_x = 0
    if ed_pos_y > 0 then ed_pos_y = 0
    
    'mouse
    getmouse mouse_x,mouse_y,,mouse_button
    mouse_ed_pos_x = fix(mouse_x/i_tss)*i_tss
    mouse_ed_pos_y = fix(mouse_y/i_tss)*i_tss
    
    'mouse box position
    ed_x = ((mouse_ed_pos_x + i_tss) / i_tss) - ed_pos_x
    ed_y = ((mouse_ed_pos_y + i_tss) / i_tss) - ed_pos_y
    map(ed_x,ed_y) = map(ed_x,ed_y)
    
    'load map
    if mouse_button = 1 then
        if ed_x <= i_mws and ed_y <= i_mws and ed_x >= 1 and ed_y >= 1 then'bug prevention - out of range
            world_x = ed_x
            world_y = ed_y
            engine = 31
            ed_pos_x = 0
            ed_pos_x = 0
            data_CSV_read()
            data_MAP_read()
            flush()
        endif
    endif
    
end sub

'-------------------------------------------------------------------------------
sub math_editor()
    
    'enter tile id
    if key_enter = true then
        dim as string input_text
        do
            color rgb(0,0,0)
            rect(20,20,200,30)
            locate 5,5:input "Tile ID: ", input_text
        loop until input_text <> ""
        ed_sel_tile = val(input_text)
    endif
    
    'stop on borders
    if ed_pos_x > 0 then ed_pos_x = 0
    if ed_pos_y > 0 then ed_pos_y = 0
    if ed_pos_x < (25 - x_max) then ed_pos_x = (25 - x_max)
    if ed_pos_y < (18 - y_max) then ed_pos_y = (18 - y_max)
    
    'mouse
    getmouse mouse_x,mouse_y,,mouse_button
    mouse_ed_pos_x = fix(mouse_x / i_tss) * i_tss
    mouse_ed_pos_y = fix(mouse_y / i_tss) * i_tss
    
    'current tile
    ed_x = ((mouse_ed_pos_x + i_tss) / i_tss) - ed_pos_x
    ed_y = ((mouse_ed_pos_y + i_tss) / i_tss) - ed_pos_y
    
    'draw new field
    if mouse_button = 1 then
        map(ed_x,ed_y) = ed_sel_tile
    endif
    
    'copy current field
    if mouse_button = 2 then
        ed_sel_tile = map(ed_x,ed_y)
    endif
    
end sub

'-------------------------------------------------------------------------------
sub math_object_editor()
    
    getmouse mouse_x,mouse_y,,mouse_button
    
    'choose object
    if mouse_button = 1 then
        if mouse_x >= sc_x_edit_def/2-32 and mouse_x <= sc_x_edit_def/2-32+64 and mouse_y >= 20 and mouse_y <= 20+64 then
            engine = 41
            flush()
        endif
    endif
    
    'rename object
    if mouse_button = 1 then
        if mouse_x >= 300 and mouse_x <= 500 and mouse_y >= 0 and mouse_y <= 14 then
            dim as string input_text
            do
                color rgb(0,0,0)
                rect(300,0,200,15)
                inc()
                locate 1,40:input "Name: ", input_text
            loop until input_text <> ""
            data_names(ed_sel_tile) = str(input_text)
        endif
    endif
    
    'choose image
    if mouse_button = 2 then
        if mouse_x >= sc_x_edit_def/2-32 and mouse_x <= sc_x_edit_def/2-32+64 and mouse_y >= 20 and mouse_y <= 20+64 then
            engine = 42
            flush()
        endif
    endif
    
    'create empty object
    if key_space = true then
        dim as ushort fn
        for fn = 1 to i_mos
            if data_id(fn) = 0 then
                data_id(fn) = fn
                data_names(fn) = "No Name"
                ed_sel_tile = fn
                exit for
            endif
        next
    endif
    
    'delete object
    if key_delete = true then
        data_id(ed_sel_tile) = 0
        data_type(ed_sel_tile) = 0
        data_names(ed_sel_tile) = ""
        data_post(ed_sel_tile) = 0
        data_block(ed_sel_tile) = 0
        data_active(ed_sel_tile) = 0
        data_image_type(ed_sel_tile) = 0
        data_image(ed_sel_tile) = 0
        data_value_1(ed_sel_tile) = 0
        data_value_2(ed_sel_tile) = 0
        data_value_3(ed_sel_tile) = 0
        data_value_4(ed_sel_tile) = 0
        data_value_5(ed_sel_tile) = 0
        data_value_6(ed_sel_tile) = 0
        data_wait(ed_sel_tile) = 0
        data_sfx(ed_sel_tile) = 0
        data_spirit(ed_sel_tile) = 0
    endif
    
    'increase and decrease
    if multikey(fb.sc_control) then
        increase=10
        decrease=-10
    elseif not multikey(fb.sc_control) then
        increase=1
        decrease=-1
    endif
    
end sub

'-------------------------------------------------------------------------------
sub map_events()
    
    #include once "math/map_events.bas"
    
end sub
