declare sub initscreen(sc_type as ubyte=0)
declare sub print2(input_text as string,pos_x as short=0,pos_y as short=0,font_center as byte=0,font_size_x as ubyte=6)'9=normal
declare sub pause_cpu()
declare sub flush()
declare sub inc(select_color as ubyte=0)
declare sub switch_items()
declare sub obed_btn(obed_btn_x as short, obed_btn_y as short, obed_btn_image as ubyte, btn_type as ushort=0, change_value as byte=1, description as string="")
declare sub playmov(mov_name as string, mov_frames as integer, mov_fps as ubyte=10)
declare sub after_event()
declare sub cheats()
declare sub level_up()
declare sub scale_screen()

'-------------------------------------------------------------------------------
sub initscreen(sc_type as ubyte=0)
    
    'set graphics driver
    select case as const sc_driver
    case 1:setenviron("fbgfx=DirectX")
    case 2:setenviron("fbgfx=GDI")
    case 3:setenviron("fbgfx=OpenGL")
    end select
    
    'resolution
    dim as ushort sc_x, sc_y, sc_full_set
    if sc_type = 0 then'game
        select case as const sc_filter
        case 1'normal
            sc_scale = false
            sc_x = sc_x_game_def
            sc_y = sc_y_game_def
        case else'scaled
            sc_scale = true
            sc_x = sc_x_game_def * 2
            sc_y = sc_y_game_def * 2
        end select
    elseif sc_type = 1 then'editor
        sc_scale = false
        sc_x = sc_x_edit_def
        sc_y = sc_y_edit_def
    endif
    
    'fullscreen
    if sc_full=1 then
        sc_full_set=&h01'fullscreen
    else
        sc_full_set=&h00'windowed
    endif
    
    'set screen
    screenres sc_x,sc_y,32,1,sc_full_set
    setmouse sc_x/2,sc_y/2,0'center mouse
    
end sub

'-------------------------------------------------------------------------------
sub print2(input_text as string,pos_x as short=0,pos_y as short=0,font_center as byte=0,font_size_x as ubyte=6)'9=normal
    
    dim as ubyte fn
    dim as uinteger text_size
    dim as ubyte font_chr
    dim as integer calc_font_center
    
    text_size = len(input_text)
    
    for fn = 1 to text_size
        font_chr=asc(input_text,fn)
        if font_chr < 254 then
            if font_center=1 then
                calc_font_center = (text_size * font_size_x) / 2
            elseif font_center=2 then
                calc_font_center = (text_size * font_size_x)
            endif
            drawimg(img_font(font_chr+1), pos_x-calc_font_center + (font_size_x * fn - font_size_x), pos_y ,3)
        endif
    next
    
end sub

'-------------------------------------------------------------------------------
sub pause_cpu()
    
    select case as const pause
    case 0
        sleep speed,1
    case 1
        getkey
        pause = 0
    end select
    
end sub

'-------------------------------------------------------------------------------
sub flush()
    
    sleep 200,1
    
end sub

'-------------------------------------------------------------------------------
sub inc(select_color as ubyte=0)
    
    select case as const select_color
    case 0:color rgb(255,255,255), rgb(0,0,0)
    case 1:color rgb(0,0,0), rgb(255,255,255)
    end select
    
end sub

'-------------------------------------------------------------------------------
sub switch_items()
    
    dim as ushort ite_sel_temp
    ite_sel_temp = itm_sel
    itm_sel = itm(itm_x,itm_y)
    itm(itm_x,itm_y) = ite_sel_temp
    
end sub

'-------------------------------------------------------------------------------
sub obed_btn(obed_btn_x as short, obed_btn_y as short, obed_btn_image as ubyte, btn_type as ushort=0, change_value as byte=1, description as string="")
    
    'button
    drawimg(img_obed_btns(obed_btn_image),obed_btn_x,obed_btn_y,3)
    
    'description
    if description <> "" then
        print2(description,obed_btn_x+20,obed_btn_y+1)
    endif
    
    'mouse hover
    if mouse_x >= obed_btn_x and mouse_x < obed_btn_x+12 and mouse_y >= obed_btn_y and mouse_y < obed_btn_y+11 then
        drawimg(img_obed_btns(obed_btn_image+1),obed_btn_x,obed_btn_y,3)
        'change values
        if mouse_button = 1 then
            select case as const btn_type
            case 1'id
                do
                    ed_sel_tile = ed_sel_tile + change_value
                loop until data_id(ed_sel_tile) > 0
                if ed_sel_tile < 0 then
                    ed_sel_tile = 0
                elseif ed_sel_tile > i_mos then
                    ed_sel_tile = i_mos
                endif
            case 2'type
                data_type(ed_sel_tile) = data_type(ed_sel_tile) + change_value
                if data_type(ed_sel_tile) < 0 then
                    data_type(ed_sel_tile) = 100 + i_ts3dr_y
                elseif data_type(ed_sel_tile) = 13 then
                    data_type(ed_sel_tile) = 100
                elseif data_type(ed_sel_tile) = 99 then
                    data_type(ed_sel_tile) = 12
                elseif data_type(ed_sel_tile) > 100 + i_ts3dr_y then
                    data_type(ed_sel_tile) = 0
                endif
            case 4'image id
                data_image(ed_sel_tile) = data_image(ed_sel_tile) + change_value
                if data_image(ed_sel_tile) > (i_tsr * i_tsr) then
                    data_image(ed_sel_tile) = 0
                elseif data_image(ed_sel_tile) < 0 then
                    data_image(ed_sel_tile) = (i_tsr * i_tsr)
                endif
            case 5'image type
                data_image_type(ed_sel_tile) = data_image_type(ed_sel_tile) + change_value
                if data_image_type(ed_sel_tile) < 0 then
                    data_image_type(ed_sel_tile) = 1
                elseif data_image_type(ed_sel_tile) > 1 then
                    data_image_type(ed_sel_tile) = 0
                endif
            case 6'auto
                if data_active(ed_sel_tile) = false then
                    data_active(ed_sel_tile) = true
                elseif data_active(ed_sel_tile) = true then
                    data_active(ed_sel_tile) = false
                endif
            case 7'after event
                dim as ushort fn
                for fn = data_post(ed_sel_tile)+1 to i_mos+1
                    data_post(ed_sel_tile) = data_post(ed_sel_tile) + change_value
                    if data_id(fn) > 0 then
                        exit for
                    endif
                next
                if data_post(ed_sel_tile) < 0 then
                    data_post(ed_sel_tile) = 0'i_mos
                elseif data_post(ed_sel_tile) > i_mos then
                    data_post(ed_sel_tile) = 0
                endif
            case 8'block
                data_block(ed_sel_tile) = data_block(ed_sel_tile) + change_value
                if data_block(ed_sel_tile) < 0 then
                    data_block(ed_sel_tile) = 2
                elseif data_block(ed_sel_tile) > 2 then
                    data_block(ed_sel_tile) = 0
                endif
            case 9'value 1
                data_value_1(ed_sel_tile) = data_value_1(ed_sel_tile) + change_value
                'select case as const data_type(ed_sel_tile)
                'case 0:
                'end select
            case 10'value 2
                data_value_2(ed_sel_tile) = data_value_2(ed_sel_tile) + change_value
            case 11'value 3
                data_value_3(ed_sel_tile) = data_value_3(ed_sel_tile) + change_value
            case 12'value 4
                data_value_4(ed_sel_tile) = data_value_4(ed_sel_tile) + change_value
            case 13'value 5
                data_value_5(ed_sel_tile) = data_value_5(ed_sel_tile) + change_value
            case 14'value 6
                data_value_6(ed_sel_tile) = data_value_6(ed_sel_tile) + change_value
            case 15'wait
                data_wait(ed_sel_tile) = data_wait(ed_sel_tile) + change_value
                if data_wait(ed_sel_tile) < 0 then
                    data_wait(ed_sel_tile) = 0
                elseif data_wait(ed_sel_tile) > 100 then
                    data_wait(ed_sel_tile) = 100
                endif
            case 16'sfx
                data_sfx(ed_sel_tile) = data_sfx(ed_sel_tile) + change_value
                if data_sfx(ed_sel_tile) < 0 then
                    data_sfx(ed_sel_tile) = 0
                elseif data_sfx(ed_sel_tile) > 250 then'max_sfx
                    data_sfx(ed_sel_tile) = 250'max_sfx
                endif
            case 17'spirit use
                data_spirit(ed_sel_tile) = data_spirit(ed_sel_tile) + change_value
                if data_spirit(ed_sel_tile) < 0 then
                    data_spirit(ed_sel_tile) = 0
                elseif data_spirit(ed_sel_tile) > 3 then
                    data_spirit(ed_sel_tile) = 3
                endif
            case 26'play sfx
                if data_sfx(ed_sel_tile) > 100 then
                    playstr(str_music(data_sfx(ed_sel_tile)-100))
                else
                    playsnd(snd_fx(data_sfx(ed_sel_tile)))
                endif
            end select
            'scrolling speed
            sleep 150,1
        endif
    endif
    
    'klicked marker
    if btn_type = 6 and data_active(ed_sel_tile) = 1 then
        drawimg(img_obed_btns(7),obed_btn_x,obed_btn_y,3)
    endif
    
end sub

'-------------------------------------------------------------------------------
sub playmov(mov_name as string, mov_frames as integer, mov_fps as ubyte=10)
    
    dim as any ptr mov_img(mov_frames)
    dim as integer frame_counter=1
    dim as any ptr mov_sound
    
    chdir(mov_name)
    
    loadstr(mov_sound,mov_name+".ogg")
    playstr(mov_sound)
    
    inc()
    cls
    
    do  
        'load frame
        mov_img(frame_counter) = pload2(str(frame_counter)+".png")
        
        'draw frame
        select case as const sc_filter
        case 1      :put (0,0),                             mov_img(frame_counter), pset
        case else   :put (sc_x_game_def/2,sc_y_game_def/2), mov_img(frame_counter), pset
        end select
        sleep mov_fps ,1
        
        'unload old frame
        deallocate mov_img(frame_counter - 1)
        
        'play movie
        frame_counter = frame_counter + 1
        
    loop until frame_counter = mov_frames or multikey(fb.sc_escape)
    
    stopstr(mov_sound)
    
    chdir("..")
    
    sleep 500,1
    
end sub

'-------------------------------------------------------------------------------
sub after_event()
    
    select case as const data_post(map(x,y))
    case 0:map(x,y) = map_type
    case 1'no replace
    case else:map(x,y) = data_post(map(x,y))
    end select
    
end sub

'-------------------------------------------------------------------------------
sub cheats()
    
    if multikey(fb.sc_tilde) then
        if draw_console = false then
            draw_console = true
        elseif draw_console = true then
            draw_console = false
        endif
    endif
    
    if draw_console = true then
        dim as string cheat, cheat_value_1, cheat_value_2
        inc(1):rect(0,0,i_dis_x,10)
        inc():locate 1,1
        input "# ",cheat,cheat_value_1,cheat_value_2
        if cheat="debug" then
            if debug = false then
                debug = true
            elseif debug = true then
                debug = false
            endif
        endif
        if cheat="die" then pl_hp = 0
        if cheat="live" then pl_hp = 1
        if cheat="ghp" then pl_hp = pl_hp_max
        if cheat="gma" then pl_ma = pl_ma_max
        if cheat="eggs" then pl_hu = pl_hu_max
        if cheat="h2o" then pl_th = pl_th_max
        if cheat="blow" then map(x,y) = map_type
        if cheat="imp" then
            select case as const pl_view
            case 1:map(x,y-1) = map_type
            case 2:map(x+1,y) = map_type
            case 3:map(x,y+1) = map_type
            case 4:map(x-1,y) = map_type
            end select
        endif
        if cheat="summon" then map(x,y) = val(cheat_value_1)
        if cheat="spock" then
            x = val(cheat_value_1)
            y = val(cheat_value_2)
        endif
        if cheat="coins" then pl_money = 99999
        if cheat="xp" then pl_xp = pl_xp_max
        if cheat="hunger" then pl_hu = 0
        if cheat="thirst" then pl_th = 0
        draw_console = false
        flush()
    endif
    
end sub

'-------------------------------------------------------------------------------
sub level_up()
    
    if pl_xp >= pl_xp_max then
        pl_xp_max = pl_xp_max + (pl_xp_max * pl_xp_mp)
        pl_xp = 0
        pl_level = pl_level + 1
        pl_hp_max = pl_hp_max + (pl_hp_max * 0.3)
        pl_str = pl_str + pl_str_mp
        pl_def = pl_def + pl_def_mp
        pl_dex = pl_dex + pl_dex_mp
        playsnd(snd_level_up)
    endif
    
end sub

'-------------------------------------------------------------------------------
sub scale_screen()
    
    'copy screen
    get (0,0) - (sc_x_game_def-1, sc_y_game_def-1), img_screen
    
    select case as const sc_filter
    case 2:imagedestroy img_screen_scale'unload old image
           img_screen_scale = ImageScale(img_screen,sc_x_game_def * 2, sc_y_game_def * 2)'D.J.Peters
    case 3:ImageScale2X_1000101 (img_screen_scale,img_screen)'1000101's eagle
    case 4:ImageEagle           (img_screen_scale,img_screen)'eagle
    end select
    
    'draw scaled screen
    put (0,0), img_screen_scale, pset
    
end sub
