'###_CREDITS_###################################################################
'Image Scaler 1.1
'2008 Innova and Kristopher Windsor
'source: http://www.freebasic.net/forum/viewtopic.php?t=9588

'###_LIBRARIES_#################################################################
#include once "fbgfx.bi"

'###_FUNCTIONES_################################################################
Sub image_scaler Overload (Byval itarget As fb.image Ptr = 0, Byval x As Integer = 0, Byval y As Integer = 0, Byval isource As fb.image Ptr, Byval scale As double)
  Dim As Integer dest_size_x, dest_size_y, dest_realsize_x, dest_realsize_y
  Dim As Integer dest_loop_x, dest_loop_y
  Dim As Integer srce_size_x, srce_size_y
  Dim As Integer srce_loop_x, srce_loop_y
  Dim As Integer dest_pitch, srce_pitch
  Dim As Integer srce_color
  Dim As Integer dest_loop_x1, dest_loop_y1, dest_loop_x2, dest_loop_y2
  Dim As double red, green, blue
  Dim As double x1, y1, x2, y2, overlap_factor, total_pixels
  Dim As double overlap_1, overlap_2, overlap_3, overlap_4, overlap_5, overlap_6 'temp variables to see how much of a certain source pixel overlaps a destination pixel
  Dim As Uinteger Ptr dest_ptr, srce_ptr
 
  If isource = 0 Then
    Screeninfo(srce_size_x, srce_size_y,,, srce_pitch)
    srce_ptr = Screenptr
  Else
    srce_size_x = isource -> Width
    srce_size_y = isource -> height
    srce_pitch = isource -> pitch
    srce_ptr = cast(Uinteger Ptr, isource + 1)
  End If
  srce_pitch Shr= 2
 
  If itarget = 0 Then
    Screeninfo(dest_realsize_x, dest_realsize_y,,, dest_pitch)
    dest_ptr = Screenptr
  Else
    dest_realsize_x = itarget -> Width
    dest_realsize_y = itarget -> height
    dest_pitch = itarget -> pitch
    dest_ptr = cast(Uinteger Ptr, itarget + 1)
  End If
  dest_pitch Shr= 2
  dest_ptr += x + y * dest_pitch
 
  'real size was used for clipping; now use this for other things
  dest_size_x = srce_size_x * scale
  dest_size_y = srce_size_y * scale
 
  'clipping
  dest_loop_x1 = 0
  dest_loop_x2 = dest_size_x - 1
  If dest_loop_x1 + x < 0 Then dest_loop_x1 = -x
  If dest_loop_x1 + x > dest_realsize_x - 1 Then dest_loop_x1 = dest_realsize_x - x - 1
  If dest_loop_x2 + x < 0 Then dest_loop_x2 = -x
  If dest_loop_x2 + x > dest_realsize_x - 1 Then dest_loop_x2 = dest_realsize_x - x - 1
 
  dest_loop_y1 = 0
  dest_loop_y2 = dest_size_y - 1
  If dest_loop_y1 + y < 0 Then dest_loop_y1 = -y
  If dest_loop_y1 + y > dest_realsize_y - 1 Then dest_loop_y1 = dest_realsize_y - y - 1
  If dest_loop_y2 + y < 0 Then dest_loop_y2 = -y
  If dest_loop_y2 + y > dest_realsize_y - 1 Then dest_loop_y2 = dest_realsize_y - y - 1
 
  'loop for each destination pixel
  For dest_loop_x = dest_loop_x1 To dest_loop_x2
    For dest_loop_y = dest_loop_y1 To dest_loop_y2
      'find the source pixels under this destination pixel
      x1 = Cdbl(dest_loop_x) / dest_size_x * srce_size_x - .5
      x2 = Cdbl(dest_loop_x + 1) / dest_size_x * srce_size_x - .5
      y1 = Cdbl(dest_loop_y) / dest_size_y * srce_size_y - .5
      y2 = Cdbl(dest_loop_y + 1) / dest_size_y * srce_size_y - .5
     
      'loop through all of the source pixels under this destination pixel to get the average color
      red = 0: green = 0: blue = 0: total_pixels = 0
      For srce_loop_x = x1 To x2
        For srce_loop_y = y1 To y2
          'the following can be replaced with 'overlap_factor = 1,' but it will be slightly less accurate (especially in the last row and column)
          'overlaps 1, 2: location of destination pixel; 3, 4: part of source pixel under destination pixel; 5, 6: location of source pixel
          'x overlap factor
          overlap_1 = Cdbl(dest_loop_x) / dest_size_x
          overlap_2 = Cdbl(dest_loop_x + 1) / dest_size_x
          overlap_3 = Cdbl(srce_loop_x) / srce_size_x
          overlap_4 = Cdbl(srce_loop_x + 1) / srce_size_x
          overlap_5 = overlap_3
          overlap_6 = overlap_4
          If overlap_3 < overlap_1 Or overlap_3 > overlap_2 Then overlap_3 = Iif(Abs(overlap_3 - overlap_1) < Abs(overlap_3 - overlap_2), overlap_1, overlap_2)
          If overlap_4 < overlap_1 Or overlap_4 > overlap_2 Then overlap_4 = Iif(Abs(overlap_4 - overlap_1) < Abs(overlap_4 - overlap_2), overlap_1, overlap_2)
          overlap_factor = Abs((overlap_3 - overlap_4) / (overlap_5 - overlap_6))
          'y overlap factor
          overlap_1 = Cdbl(dest_loop_y) / dest_size_y
          overlap_2 = Cdbl(dest_loop_y + 1) / dest_size_y
          overlap_3 = Cdbl(srce_loop_y) / srce_size_y
          overlap_4 = Cdbl(srce_loop_y + 1) / srce_size_y
          overlap_5 = overlap_3
          overlap_6 = overlap_4
          If overlap_3 < overlap_1 Or overlap_3 > overlap_2 Then overlap_3 = Iif(Abs(overlap_3 - overlap_1) < Abs(overlap_3 - overlap_2), overlap_1, overlap_2)
          If overlap_4 < overlap_1 Or overlap_4 > overlap_2 Then overlap_4 = Iif(Abs(overlap_4 - overlap_1) < Abs(overlap_4 - overlap_2), overlap_1, overlap_2)
          overlap_factor *= Abs((overlap_3 - overlap_4) / (overlap_5 - overlap_6))
         
          'overlap_factor = 1
          If overlap_factor > 1E-6 Then
            total_pixels += overlap_factor 'if all of the source pixel is under the destination pixel, then a whole pixel is added
            'point()
            srce_color = *(srce_ptr + srce_loop_x + srce_loop_y * srce_pitch)
            red += ((srce_color And &H00FF0000) Shr 16) * overlap_factor
            green += ((srce_color And &H0000FF00) Shr 8) * overlap_factor
            blue += (srce_color And &H000000FF) * overlap_factor
          End If
        Next srce_loop_y
      Next srce_loop_x
      red /= total_pixels: green /= total_pixels: blue /= total_pixels
     
      'draw (pset())
      *(dest_ptr + dest_loop_x + dest_loop_y * dest_pitch) = (&HFF000000) Or (red Shl 16) Or (green Shl 8) Or blue
    Next dest_loop_y
  Next dest_loop_x
End Sub

Sub image_scaler Overload (Byval x As Integer = 0, Byval y As Integer = 0, Byval source As fb.image Ptr, Byval scale As double)
  image_scaler 0, x, y, source, scale
End Sub

'###_EXAMPLE_###################################################################
/'
Dim As Integer x, y
Dim Shared As fb.image Ptr picture

Screenres 800, 600, 32
Setmouse 256, 256, 0

picture = imagecreate(256, 256, &HFF00FF00)
Line picture, (0, 0) - (255, 255), &HFFFF0000, B
Circle picture, (100, 100), 50, &HFF000000
Circle picture, (150, 150), 5, &HFFFFFF00
Line picture, (100, 0) - (100, 100), &HFF00FFFF
Pset picture, (8, 8), &HFF000000

Do
  If Getmouse(x, y) = 0 Then
    Screenlock
    Cls
    image_scaler 0, 0, picture, x / 256
    image_scaler x, y, picture, x / 512
    Screenunlock
  End If
  Sleep 10
Loop Until Inkey = Chr(27)
System
'/
