'###_CREDITS_###################################################################
'imagescale
'2008 by D.J.Peters
'source: http://www.freebasic.net/forum/viewtopic.php?p=91780

'###_LIBRARIES_#################################################################
#include once "fbgfx.bi"

'###_FUNCTIONES_################################################################
function ImageScale(s as fb.Image ptr, _
                    w as integer, _
                    h as integer) as fb.Image ptr
  if s        =0 then return 0
  if s->width <1 then return 0
  if s->height<1 then return 0
  if w<4 then w=4
  if h<4 then h=4
  dim as fb.Image ptr t=ImageCreate(w,h)
  dim as integer xs=(s->width /t->Width ) * (1024*64)
  dim as integer ys=(s->height/t->height) * (1024*64)
  dim as integer x,y,sy
  select case as const s->bpp
    case 1
      dim as ubyte ptr ps=cptr(ubyte ptr,s)+32
      dim as uinteger   sp=s->pitch
      dim as ubyte ptr pt=cptr(ubyte ptr,t)+32
      dim as uinteger   tp=t->pitch-t->width
      for ty as integer = 0 to t->height-1
        dim as ubyte ptr src=ps+(sy shr 16)*sp
        for tx as integer = 0 to t->width-1
          *pt=src[x shr 16]:pt+=1:x+=xs
        next
        pt+=tp:sy+=ys:x=0
      next
    case 2
      dim as ushort ptr ps=cptr(ushort ptr,s)+16
      dim as uinteger   sp=(s->pitch shr 1)
      dim as ushort ptr pt=cptr(ushort ptr,t)+16
      dim as uinteger   tp=(t->pitch shr 1)-t->width
      for ty as integer = 0 to t->height-1
        dim as ushort ptr src=ps+(sy shr 16)*sp
        for tx as integer = 0 to t->width-1
          *pt=src[x shr 16]:pt+=1:x+=xs
        next
        pt+=tp:sy+=ys:x=0
      next
    case 4
      dim as uinteger ptr ps=cptr(uinteger ptr,s)+8
      dim as uinteger     sp=(s->pitch shr 2)
      dim as uinteger ptr pt=cptr(uinteger ptr,t)+8
      dim as uinteger     tp=(t->pitch shr 2)-t->width
      for ty as integer = 0 to t->height-1
        dim as uinteger ptr src=ps+(sy shr 16)*sp
        for tx as integer = 0 to t->width-1
          *pt=src[x shr 16]:pt+=1:x+=xs
        next
        pt+=tp:sy+=ys:x=0
      next
  end select
  return t
end function

'###_EXAMPLE_###################################################################
'NewImage = ImageScale(SourceImage,width,height)
