'###_CREDITS_###################################################################
'sndloader 1.1
'2008-2011 by N3trunn3r
'n3trunn3r@catbone.freebasic.net
'http://catbone.freebasic.net/
'written for FreeBASIC version 0.21.1

'###_LIBRARIES_#################################################################
#include once "fmod.bi"
#include once "n3trunn3r/error.bas"

'###_SHARED_VALUES_#############################################################
dim shared as ubyte volume_music=96, volume_sound=196

'###_FUNCTIONES_################################################################
declare sub loadsnd(byref sound_name as integer ptr,sound_path as string)
declare sub playsnd(sound_name as integer ptr)
declare sub loadstr(byref stream_name as integer ptr,stream_path as string,stream_loop as byte=0)
declare sub playstr(stream_name as integer ptr)
declare sub pausstr(pause_value as byte=1)
declare sub stopstr(stream_name as integer ptr)
declare sub initsnd()
declare sub endsnd()

'-------------------------------------------------------------------------------
sub loadsnd(byref sound_name as integer ptr,sound_path as string)
    
    sound_name=FSOUND_SAMPLE_Load(FSOUND_FREE,sound_path,0,0,0)
    
    if sound_path = "" then er("loadsnd: invalid path")
    
end sub

'-------------------------------------------------------------------------------
sub playsnd(sound_name as integer ptr)
    
    if sound_name = 0 then er("playsnd: invalid sound")
    
    FSOUND_PlaySound (FSOUND_FREE,sound_name)
    FSOUND_SetSFXMasterVolume(volume_sound)
    
end sub

'-------------------------------------------------------------------------------
sub loadstr(byref stream_name as integer ptr,stream_path as string,stream_loop as byte=0)
    
    if stream_loop = 1 then
        stream_name=FSOUND_Stream_Open(stream_path,FSOUND_LOOP_NORMAL,0,0)
    else
        stream_name=FSOUND_Stream_Open(stream_path,0,0,0)
    endif
    
    if stream_name = 0 then er("loadstr: invalid path")
    
end sub

'-------------------------------------------------------------------------------
sub playstr(stream_name as integer ptr)
    
    if stream_name = 0 then er("playstr: invalid stream")
    
    FSOUND_Stream_Play(1,stream_name)
    FSOUND_SetVolumeAbsolute(1,volume_music)
    
end sub

'-------------------------------------------------------------------------------
sub pausstr(pause_value as byte=1)
    
    FSOUND_SetPaused(1,pause_value)
    
end sub

'-------------------------------------------------------------------------------
sub stopstr(stream_name as integer ptr)
    
    if stream_name = 0 then er("stopstr: invalid stream")
    
    FSOUND_Stream_Stop stream_name
    FSOUND_Stream_Close stream_name
    
end sub

'-------------------------------------------------------------------------------
sub initsnd()
    
    FSOUND_Init(44100,8,0)
    
end sub

'-------------------------------------------------------------------------------
sub endsnd()
    
    FSOUND_Close
    
end sub
