'###_SHARED_VALUES_#############################################################
'engine-------------------------------------------------------------------------
'config
const      as byte      true=1, false=0
const      as string    version="1.8"
const      as string    error_read="Read Error: "
const      as string    error_write="Write Error: "
dim shared as byte      feedback=0

'screen
dim shared as byte      sc_full=0
dim shared as byte      sc_intro=1
dim shared as byte      sc_filter=2
dim shared as byte      sc_driver=1
dim shared as byte      sc_scale
const      as ushort    sc_x_game_def=320
const      as ushort    sc_y_game_def=240
const      as ushort    sc_x_edit_def=800
const      as ushort    sc_y_edit_def=600

'engine
const      as ushort    speed_def=10'cpu use
dim shared as ushort    speed=speed_def
dim shared as ubyte     engine=1'loading
dim shared as byte      pause
dim shared as byte      debug
dim shared as byte      auto_play

'input--------------------------------------------------------------------------
'mouse
dim shared as integer   mouse_x
dim shared as integer   mouse_y
dim shared as integer   mouse_button

'keyboard
dim shared as byte      key_hit'any key
dim shared as byte      key_exit, key_enter, key_space, key_delete, key_back, key_down, key_up, key_left, key_right

'interface----------------------------------------------------------------------
'images
const      as ushort    i_dis_x=320'dungeon 3d image size x
const      as ushort    i_dis_y=240'dungeon 3d image size y
const      as ubyte     i_tss=32'tileset size
const      as ushort    i_tsr=11'tileset rows
const      as ushort    i_ts3dr_x=21'tileset 3d rows x
const      as ushort    i_ts3dr_y=3'tileset 3d rows y

'data size
const      as ushort    i_mds=(i_tsr * i_tsr)'max data size
const      as ushort    i_mos=500'max objects
const      as ubyte     i_mms=50'max map size
const      as ubyte     i_mws=16'max world map size
const      as ubyte     max_sfx=100'max sound effects

'images bagpack
const      as ubyte     itm_x_max=13
const      as ubyte     itm_y_max=7
const      as ubyte     itm_st=6'start position x y
const      as byte      itm_sp=5'spacer size
const      as byte      itm_sq=18'square size

'menu---------------------------------------------------------------------------
dim shared as byte      i_menu
dim shared as byte      i_menu_cur_pos

'game---------------------------------------------------------------------------
'map position
dim shared as short     x'player position
dim shared as short     y
dim shared as short     x_old'last player position
dim shared as short     y_old
dim shared as ubyte     x_max'map width
dim shared as ubyte     y_max'map height
dim shared as ushort    map(i_mms,i_mms)'map data
dim shared as ubyte     map_type'used to replace items, monsters after vanishing and default tile

'world map position
dim shared as short     world_x'world position
dim shared as short     world_y

'editor
dim shared as ushort    mouse_ed_pos_x'actual tile position
dim shared as ushort    mouse_ed_pos_y
dim shared as integer   ed_x
dim shared as integer   ed_y
dim shared as short     ed_pos_x'view position
dim shared as short     ed_pos_y
dim shared as ushort    ed_sel_tile'tile selected to draw

'object editor
dim shared as byte      increase
dim shared as byte      decrease

'tile chooser
'dim shared as ushort    switch_id_a
'dim shared as ushort    switch_id_b

'items
dim shared as ushort    itm_x=1'item cursor position
dim shared as ushort    itm_y=1
dim shared as ushort    itm(itm_x_max,itm_y_max)'items
dim shared as ushort    itm_sel'item picked up by cursor

'misc
dim shared as ubyte     pl_view
dim shared as byte      pl_move'forwared and backward movement
dim shared as short     en_hp(i_mms,i_mms)
dim shared as byte      mini_map(i_mms,i_mms)
dim shared as byte      draw_msg
dim shared as byte      draw_mini_map
dim shared as byte      draw_compass
dim shared as byte      fight_round
dim shared as byte      fight_anim
dim shared as ushort    pl_atk
dim shared as ushort    en_atk
dim shared as ubyte     ani_en_move
dim shared as byte      choice
dim shared as byte      rnd_floor
dim shared as byte      draw_console

'player
const      as ubyte     pl_xp_mp=2'multiplier
const      as ubyte     pl_str_mp=1, pl_dex_mp=1, pl_def_mp=1'multiplier
dim shared as short     pl_hp, pl_hp_max'health
dim shared as short     pl_ma, pl_ma_max'mana
dim shared as short     pl_hu, pl_hu_max
dim shared as byte      pl_hu_drain'hunger
dim shared as short     pl_th, pl_th_max
dim shared as byte      pl_th_drain'thirst
dim shared as uinteger  pl_xp, pl_xp_max
dim shared as short     pl_str, pl_dex, pl_def
dim shared as ubyte     pl_level
dim shared as byte      pl_fire'fire resistance
dim shared as byte      pl_ice'ice resistance
dim shared as uinteger  pl_money
dim shared as ushort    pl_ma_load

'file_data----------------------------------------------------------------------
dim shared as string    data_strings(i_mos)

dim shared as short     data_id(i_mos)
dim shared as byte      data_type(i_mos)
dim shared as string    data_names(i_mos)
dim shared as short     data_post(i_mos)
dim shared as byte      data_block(i_mos)
dim shared as byte      data_active(i_mos)
dim shared as byte      data_image_type(i_mos)
dim shared as short     data_image(i_mos)
dim shared as short     data_value_1(i_mos)
dim shared as short     data_value_2(i_mos)
dim shared as short     data_value_3(i_mos)
dim shared as short     data_value_4(i_mos)
dim shared as short     data_value_5(i_mos)
dim shared as short     data_value_6(i_mos)
dim shared as short     data_wait(i_mos)
dim shared as short     data_sfx(i_mos)
dim shared as short     data_spirit(i_mos)

'gfx----------------------------------------------------------------------------
'map
dim shared as any ptr   img_tiles(i_mds)
dim shared as any ptr   img_tiles_1x0c5x(i_mds), img_tiles_2x1x(i_mds), img_tiles_5x2x(i_mds)
dim shared as any ptr   img_tiles_2x(i_mds), img_tiles_5x(i_mds)
dim shared as any ptr   img_tiles_3d(i_ts3dr_x * i_ts3dr_y)
dim shared as any ptr   img_items_big(i_mds)

'gui
dim shared as any ptr   img_freebasic(1)
dim shared as any ptr   img_font(254)
dim shared as any ptr   img_gui(1)
dim shared as any ptr   img_gui_death(1)
dim shared as any ptr   img_enemy_hp_bar(1)
dim shared as any ptr   img_bagpack(1)
dim shared as any ptr   img_bcur(1)
dim shared as any ptr   img_choice(1)
dim shared as any ptr   img_compass(4)
dim shared as any ptr   img_hit(1)
dim shared as any ptr   img_slice(1)
dim shared as any ptr   img_menu_bg(1)
dim shared as any ptr   img_menu_1(1)
dim shared as any ptr   img_menu_2(1)
dim shared as any ptr   img_menu_3(1)
dim shared as any ptr   img_menu_cursor(1)
dim shared as any ptr   img_mini_map(1)
dim shared as any ptr   img_mouse(1)
dim shared as any ptr   img_block(7)
dim shared as any ptr   img_obed_bg(1), img_obed_bg_2x(1)
dim shared as any ptr   img_obed_btns(9)
dim shared as any ptr   img_obed_mouse(1)
dim shared as any ptr   img_text_frame(1)
dim shared as any ptr   img_text_frame_editor(1)
dim shared as any ptr   img_world_map(1)

dim shared as any ptr   img_screen
dim shared as any ptr   img_screen_scale

'sfx
dim shared as any ptr   snd_fx(max_sfx)

dim shared as any ptr   snd_backspace
dim shared as any ptr   snd_combine
dim shared as any ptr   snd_death
dim shared as any ptr   snd_escape
dim shared as any ptr   snd_fight_die
dim shared as any ptr   snd_fight_hit
dim shared as any ptr   snd_fight_miss
dim shared as any ptr   snd_fight_pain
dim shared as any ptr   snd_freebasic
dim shared as any ptr   snd_item
dim shared as any ptr   snd_level_up
dim shared as any ptr   snd_menu_scroll
dim shared as any ptr   snd_menu_enter

dim shared as any ptr   str_menu
dim shared as any ptr   str_music(10)

'files--------------------------------------------------------------------------
'game data
dim shared as integer   file_gamedata
dim shared as string    file_gamedata_path:file_gamedata_path="gamedata.csv"

'text
dim shared as integer   file_strings
dim shared as string    file_strings_path:file_strings_path="strings.csv"

'save game
dim shared as integer   file_save
dim shared as string    file_save_path:file_save_path="save.save"

'configuration
dim shared as integer   file_cfg
dim shared as string    file_cfg_path:file_cfg_path="Witchcraft.cfg"

'maps
dim as ubyte fn_x, fn_y
dim shared as integer   file_map(i_mws,i_mws)
dim shared as string    file_map_path(i_mws,i_mws)
dim shared as integer   file_map_save(i_mws,i_mws)
dim shared as string    file_map_save_path(i_mws,i_mws)
dim shared as integer   file_en_hp_save(i_mws,i_mws)
dim shared as string    file_en_hp_save_path(i_mws,i_mws)

for fn_x = 1 to i_mws
    for fn_y = 1 to i_mws
        file_map_path(fn_x,fn_y)="map"+str(fn_x)+str(fn_y)+".map"
        file_map_save_path(fn_x,fn_y)="map"+str(fn_x)+str(fn_y)+".save"
        file_en_hp_save_path(fn_x,fn_y)="en_hp"+str(fn_x)+str(fn_y)+".save"
    next
next

dim shared as integer   file_map_use
dim shared as string    file_map_path_use
