defint a-z
option explicit
option byval

'$include: 'fbgfx.bi'
'$include: 'noise.bas'

const xres = 320
const yres = 240
const bpp = 32
const tilesize = 32
const maxx% = (xres/tilesize)*32
const maxy% = (yres/tilesize)*32
const startx% = (maxx%/2)
const starty% = (maxy%/2)
const fps = 30
const maxmines = 256
const dtinterval = 0.25
const maxframes = 256
const maxdtiles = 256

type mineT
	inuse as integer
	x as double
	y as double
end type

type dtileT
	inuse as integer
	frames as integer
	tile as integer
	frmx(0 to maxframes) as double
	frmy(0 to maxframes) as double
end type

dim as integer tiles = 10
dim mines(0 to maxmines-1) as mineT
dim map(0 to maxx-1, 0 to maxy-1) as integer
redim tile(1 to tiles, 0 to 32*32+4) as integer
redim dtile(1 to maxdtiles) as dtileT
dim antimine(0 to 0, 0 to 12*12*4) as integer
dim deminer(0 to 16*16+4) as integer
dim filename as string
dim cursor(0 to 16*16+4) as integer
dim as string ky
dim as double curx, cury, selxd, selyd, selxdt, selydt
dim as integer curtile = 1
dim as integer selx, sely
dim as integer mousex, mousey, buttons
dim as double framestart
dim as integer i, j, k, f
dim as double deminerx, deminery
dim as double tx, ty
dim as integer newfile = 0, changes = 0
dim as integer minecount, dtilecount
dim as integer curdtile = 0, curframe = 0

screenres xres, yres, bpp, 2, &h1
setmouse xres/2, yres/2, 0
screenset 1, 0

filename = rtrim$(ltrim$(command$))
if filename = "" then

	filename = ltrim$(str$(fix(timer) mod 1000000))

end if

filename = "levels/" + filename + ".amm"

f = freefile
open filename for binary as #f

if lof(f) = 0 then

	close #f
	kill filename
	newfile = 1

else
	
	get #f, , tiles

	redim tile(1 to tiles, 0 to 32*32+4) as integer
	
	get #f, , tile()
	get #f, , map()
	get #f, , deminerx
	get #f, , deminery

	if not eof(f) then
		get #f, , minecount
		get #f, , mines()
	end if

	if not eof(f) then
		get #f, , dtilecount
		if dtilecount > 0 then
			redim dtiletmp(1 to dtilecount) as dtileT
			get #f, , dtiletmp()
			for i = 1 to dtilecount
				dtile(i) = dtiletmp(i)
			next i
		end if
	end if

	close #f
end if

if newfile then
	for i = 1 to tiles

		bload "graphics/tile" + ltrim$(str$(i)) + ".bmp", varptr(tile(i, 0))
		noise rgb(255, 0, 255), varptr(tile(i, 0)), rgb(32, 32, 32), rgb(192, 192, 192)

	next i
end if

bload "graphics/cursor.bmp", varptr(cursor(0))
bload "graphics/deminer1.bmp", varptr(deminer(0))
bload "graphics/antimine1.bmp", varptr(antimine(0, 0))

if newfile then

	deminerx = startx
	deminery = starty

end if

curx = startx - (xres/tilesize/2)
cury = starty - (yres/tilesize/2)

do

	framestart = timer

	getmouse mousex, mousey, , buttons
	ky = lcase$(inkey$)

	if mousex = xres-1 then
		curx = curx + 20/fps
	elseif mousex = 0 then
		curx = curx - 20/fps
	end if

	if mousey = yres-1 then
		cury = cury + 20/fps
	elseif mousey = 0 then
		cury = cury - 20/fps
	end if

	if curx < 0 then curx = 0
	if curx > fix(maxx-(xres/tilesize)) then
		curx = fix(maxx-(xres/tilesize))
	end if
	if cury < 0 then cury = 0
	if cury > fix(maxy-(yres/tilesize)) then
		cury = fix(maxy-(yres/tilesize))
	end if
	
	if ky = "." then curtile = (curtile + 1)
	if ky = "," then curtile = (curtile - 1)

	if curtile <= 0 then curtile = tiles
	if curtile > tiles then curtile = 1
	
	selxd = curx + mousex/tilesize
	selyd = cury + mousey/tilesize
	selx = fix(selxd)
	sely = fix(selyd)

	selxdt = fix(selxd * 2) / 2
	selydt = fix(selyd * 2) / 2

	if curdtile > 0 then

		' dtile functions

		if multikey(SC_Q) then curdtile = 0

		if ky$ = "=" then
			if curframe <= dtile(curdtile).frames then curframe += 1
		end if

		if ky$ = "-" then
			if curframe > 0 then curframe -= 1
		end if
		
		if ky$ = "t" then
			dtile(curdtile).tile = curtile
			changes = 1
		end if

		if ky$ = "d" then

			if dtile(curdtile).frames > 0 and curframe <= dtile(curdtile).frames then

				for i = curframe+1 to dtile(curdtile).frames
					dtile(curdtile).frmx(i-1) = dtile(curdtile).frmx(i)
					dtile(curdtile).frmy(i-1) = dtile(curdtile).frmy(i)
				next i

				dtile(curdtile).frames -= 1

				if curframe = dtile(curdtile).frames and curframe > 0 then curframe -= 1

				changes = 1

			end if

		end if

		if ky$ = "i" then

			dtile(curdtile).frames += 1
			
			for i = dtile(curdtile).frames to curframe+1 step -1
				dtile(curdtile).frmx(i) = dtile(curdtile).frmx(i-1)
				dtile(curdtile).frmy(i) = dtile(curdtile).frmy(i-1)
			next i
		
		end if

		if buttons and 1 then

			dtile(curdtile).frmx(curframe) = selxdt
			dtile(curdtile).frmy(curframe) = selydt

			if curframe > dtile(curdtile).frames then dtile(curdtile).frames = curframe

			changes = 1

		end if

		goto skipNormalFunctions		
	
	end if

	if multikey(SC_E) then

		for i = 1 to maxdtiles
			if dtile(i).inuse = 1 and abs(selx - dtile(i).frmx(0)) < 0.55 and abs(sely - dtile(i).frmy(0)) < 0.55 then
				curdtile = i
				curframe = curframe mod (dtile(curdtile).frames+1)
				exit for
			end if			
		next i
	
	end if

	if buttons and 1 then map(selx, sely) = curtile: changes = 1
	if buttons and 2 then 
		changes = 1
		for i = 1 to maxmines-1
			if mines(i).inuse then
				tx = (mines(i).x - curx) * tilesize
				ty = (mines(i).y - cury) * tilesize
				tx = tx - mousex
				ty = ty - mousey
				if sqr(tx*tx + ty*ty) <= 6 then
					mines(i).inuse = 0
					exit for
				end if
			end if
		next i
		
		if i = maxmines then
			for i = 1 to maxdtiles
				if dtile(i).inuse = 1 and abs(selx - dtile(i).frmx(0)) < 0.55 and abs(sely - dtile(i).frmy(0)) < 0.55 then
					dtile(i).inuse = 0
					exit for
				end if			
			next i
			if i = maxdtiles+1 then
				map(selx, sely) = 0
			else
				do
					getmouse mousex, mousey, , buttons
				loop until (buttons and 2) = 0
			end if
		else
			do
				getmouse mousex, mousey, , buttons
			loop until (buttons and 2) = 0
		end if				
	end if

	if multikey(SC_D) then

		deminerx = selxd
		deminery = selyd
		changes = 1

	end if

	if multikey(SC_T) then

		for i = 1 to maxdtiles
                        if dtile(i).inuse and selx = dtile(i).frmx(0) and sely = dtile(i).frmy(0) then
				exit for
			end if
		next i

		if i <= maxdtiles then

			beep

		else

			for i = 1 to maxdtiles
	
				if dtile(i).inuse = 0 then

					dtile(i).inuse = 1
					dtile(i).frames = 0
					dtile(i).frmx(0) = selx
					dtile(i).frmy(0) = sely
					dtile(i).tile = curtile
					changes = 1
					exit for
			
				end if
		
			next i

		end if
		
		while multikey(SC_T): wend
	
	end if

	if multikey(SC_M) then

		for i = 1 to maxmines-1

			if mines(i).inuse = 0 then
				
				mines(i).inuse = 1
				mines(i).x = selxd
				mines(i).y = selyd
				changes = 1
				exit for
				
			end if
		
		next i

		while multikey(SC_M): wend

	end if

skipNormalFunctions:

	if lcase$(ky$) = "s" then

		f = freefile
		open filename for binary as #f
		if lof(f) > 0 then
			close #f
			kill filename
		else
			close #f
		end if

		f = freefile
		open filename for binary as #f

		put #f, , tiles
		put #f, , tile()
		put #f, , map()
		put #f, , deminerx
		put #f, , deminery

		minecount = 0
		for i = 1 to maxmines-1
			if mines(i).inuse then minecount += 1
		next i

		put #f, , minecount
		put #f, , mines()

		minecount = 0 ' *** dtilecount
		for i = 1 to maxdtiles
			if dtile(i).inuse then minecount += 1
		next i

		put #f, , minecount ' *** dtile count

		if minecount > 0 then

			redim dtiletmp(1 to minecount) as dtileT

			j = 1
			for i = 1 to maxdtiles
				if dtile(i).inuse then
					dtiletmp(j) = dtile(i)
					j += 1
				end if
			next i

			put #f, , dtiletmp()

		end if

		close #f
		newfile = 0
		changes = 0

	end if

	if ky$ = "1" then

		cleari rgb(255, 0, 255), varptr(tile(curtile, 0))
		noise rgb(255, 0, 255), varptr(tile(curtile, 0)), rgb(32, 32, 32), rgb(192, 192, 192)
		changes = 1

	end if
	if ky$ = "2" then

		cleari rgb(255, 0, 255), varptr(tile(curtile, 0))
		noise rgb(255, 0, 255), varptr(tile(curtile, 0)), rgb(32, 0, 0), rgb(192, 0, 0)
		changes = 1

	end if
	if ky$ = "3" then

		cleari rgb(255, 0, 255), varptr(tile(curtile, 0))
		noise rgb(255, 0, 255), varptr(tile(curtile, 0)), rgb(0, 0, 32), rgb(0, 0, 192)
		changes = 1

	end if
	if ky$ = "4" then

		cleari rgb(255, 0, 255), varptr(tile(curtile, 0))
		noise rgb(255, 0, 255), varptr(tile(curtile, 0)), rgb(0, 32, 0), rgb(0, 192, 0)
		changes = 1

	end if
	if ky$ = "5" then

		cleari rgb(255, 0, 255), varptr(tile(curtile, 0))
		noise rgb(255, 0, 255), varptr(tile(curtile, 0)), rgb(32, 32, 0), rgb(192, 192, 0)
		changes = 1

	end if

	cls
	
	dim as integer offx, offy
	
	offx = tilesize-(fix(curx*tilesize) mod tilesize)
	offy = tilesize-(fix(cury*tilesize) mod tilesize)
	
	dim as integer xx, yy, xx2, yy2
	
	for xx = -1 to cint(xres/tilesize)+1
		for yy = -1 to cint(yres/tilesize)+1
			line (xx*tilesize+offx, yy*tilesize+offy)-_
                 step(tilesize, tilesize), rgb(48, 48, 48), B

			if curdtile then

				line (xx*tilesize+offx, yy*tilesize+offy)-_
    	             step(tilesize/2, tilesize/2), rgb(48, 48, 48), B

				line (xx*tilesize+offx, yy*tilesize+offy)-_
    	             step(tilesize/2, tilesize), rgb(48, 48, 48), B

				line (xx*tilesize+offx, yy*tilesize+offy)-_
    	             step(tilesize, tilesize/2), rgb(48, 48, 48), B

			end if

			xx2 = xx+fix(curx)
			yy2 = yy+fix(cury)

			if xx2 >= 0 and yy2 >=0 and xx2 < maxx and yy2 < maxy then
				if map(xx2, yy2) then
					put ((xx-1)*tilesize+offx, (yy-1)*tilesize+offy), _
						tile(map(xx2, yy2), 0), trans
				end if
			end if

			if curdtile = 0 then

				if (xx2 = selx) and (yy2 = sely) then
					line ((xx-1)*tilesize+offx, (yy-1)*tilesize+offy)- _
        	            step(tilesize-1, tilesize-1), rgb(255, 255, 255), B
				end if
				
			end if

		next yy
	next xx


	for i = 1 to maxmines-1

		if mines(i).inuse then

			tx = (mines(i).x - curx) * tilesize
			ty = (mines(i).y - cury) * tilesize

			if tx >= -6 and ty >= -6 and tx < 326 and ty < 246 then

				put (tx-6, ty-6), antimine(0, 0), trans

			end if
		
		end if
	
	next i

	for i = 1 to maxdtiles

		if dtile(i).inuse then

			dim as integer frm = curframe mod (dtile(i).frames+1)

			if i = curdtile or curdtile = 0 then frm = 0
	
			xx2 = fix(dtile(i).frmx(frm)*tilesize) - (fix(curx)*tilesize+(tilesize-offx))
			yy2 = fix(dtile(i).frmy(frm)*tilesize) - (fix(cury)*tilesize+(tilesize-offy))

			put (xx2, yy2), tile(dtile(i).tile, 0), trans

			if i = curdtile then
				line (xx2, yy2)-step(tilesize-1, tilesize-1), rgb(0, 255, 0), b
			else
				line (xx2, yy2)-step(tilesize-1, tilesize-1), rgb(255, 0, 0), b
			end if
		
		end if
	
	next i

	for j = 1 to maxdtiles
		if dtile(j).inuse and j <> curdtile then

			xx2 = fix(dtile(j).frmx(0)*tilesize) - (fix(curx)*tilesize+(tilesize-offx))
			yy2 = fix(dtile(j).frmy(0)*tilesize) - (fix(cury)*tilesize+(tilesize-offy))

			for i = 1 to dtile(j).frames
	
				xx = xx2
				yy = yy2
				xx2 = fix(dtile(j).frmx(i)*tilesize) - (fix(curx)*tilesize+(tilesize-offx))
				yy2 = fix(dtile(j).frmy(i)*tilesize) - (fix(cury)*tilesize+(tilesize-offy))

				line (xx+16, yy+16)-(xx2+16, yy2+16), rgb(63, 0, 0)

				dim as double t

				t = sqr((i / dtile(j).frames) * 0.75 + 0.25)
				circle (xx2+16, yy2+16), 6*t, rgb(32 + 32*t, 0, 0)

			next i

		end if
	next j

	if curdtile then

		xx2 = fix(dtile(curdtile).frmx(0)*tilesize) - (fix(curx)*tilesize+(tilesize-offx))
		yy2 = fix(dtile(curdtile).frmy(0)*tilesize) - (fix(cury)*tilesize+(tilesize-offy))

		for i = 1 to dtile(curdtile).frames

			xx = xx2
			yy = yy2
			xx2 = fix(dtile(curdtile).frmx(i)*tilesize) - (fix(curx)*tilesize+(tilesize-offx))
			yy2 = fix(dtile(curdtile).frmy(i)*tilesize) - (fix(cury)*tilesize+(tilesize-offy))

			line (xx+16, yy+16)-(xx2+16, yy2+16), rgb(0, 255, 0)

			dim as double t

			t = sqr((i / dtile(curdtile).frames) * 0.75 + 0.25)
'			t = (i / dtile(curdtile).frames) * 0.5 + 0.25

			circle (xx2+16, yy2+16), 6*t, rgb(0, 127 + 127*t, 0)		

		next i

		if dtile(curdtile).frames >= curframe then

			xx2 = fix(dtile(curdtile).frmx(curframe)*tilesize) - (fix(curx)*tilesize+(tilesize-offx))
			yy2 = fix(dtile(curdtile).frmy(curframe)*tilesize) - (fix(cury)*tilesize+(tilesize-offy))

			line (xx2, yy2)-step(tilesize-1, tilesize-1), rgb(0, 0, 255), B

		end if

		xx2 = fix(selxdt*tilesize) - (fix(curx)*tilesize+(tilesize-offx))
		yy2 = fix(selydt*tilesize) - (fix(cury)*tilesize+(tilesize-offy))

		line (xx2, yy2)-step(tilesize-1, tilesize-1), rgb(255, 255, 255), B

	end if
	
	put (xres-tilesize-6, 5), tile(curtile, 0), alpha, 128
	line (xres-tilesize-6, 5)-step(tilesize, tilesize), rgb(128, 128, 128), B

	xx = (deminerx - curx) * tilesize
	yy = (deminery - cury) * tilesize

	put (xx, yy), deminer(0), trans
	
	put (mousex, mousey), cursor(0), alpha, 128

	locate 1, 1: print selx; ","; sely; " ", filename;
	if newfile then print "(new)";
	if changes then print "*";

	if curdtile then
		locate 30, 6: print "Editing DTile, Frame:";curframe;" /"; dtile(curdtile).frames;
	end if

	while (timer - framestart) < (1/fps): wend
	pcopy 1,0

loop until multikey(SC_ESCAPE)
