#version 130
uniform sampler2D texture;
uniform vec4 fontbg;
in vec4 texCoord;
in vec4 colordata;

void main(void) {

	vec4 color = texture2D(texture, texCoord.st);
	
	float factor = ( abs(fontbg.r - color.r) + abs(fontbg.g - color.g) + abs(fontbg.b - color.b) ) / 3.0;
	color.a *= 1.0 - max(0.0, fontbg.a - factor);

	if (color.a < 0.1) discard;
	
	color.rgb *= colordata.rgb; // multiply colordata
	gl_FragColor = color;

}
