#version 130
#extension GL_EXT_gpu_shader4 : enable
uniform sampler2DArray texture;
uniform vec3 focal;

in vec3 texCoord;
in vec4 colordata;
in float vertdist;
in float worldLight;

const float SHADOW_EXP = 1.0;
const float SHADOW_MUL = 1.2;
const float SHADOW_MAX = 0.98;

const float FOG_DENSITY   = 0.5;
const float FOG_LUMINANCE = 0.5;
const float FOG_MAXIMUM   = 0.2;

/*
vec4 hjemmebakt_fog(vec4 color){
	float f = min(FOG_MAXIMUM, pow(vertdist / focal[2] * 1.05, 1.25) * FOG_DENSITY);
	float lum = min(1.0, (0.7 + 0.2126 * color.r + 0.7152 * color.g + 0.0722 * color.b) * FOG_LUMINANCE);
	return vec4(mix(color.rgb, vec3(lum), f), color[3]);
}
*/

void main(void) {

	vec4 color = texture2DArray(texture, texCoord);
	if (color[3] == 0.0) discard; //le discard!
	
	color.rgb *= worldLight;
	
	// upramp shadow gamma
	float alpha = min(SHADOW_MAX,
					smoothstep(0.0, 1.0, pow(colordata[3], 0.9) )
					);
	
	color = vec4(mix(color.rgb, colordata.rgb, alpha), 1.0);
	gl_FragColor = color;

}
