option byval
option explicit

'$include: 'bass.bi'

declare sub soundInit ( soundVol as integer, musicVol as integer )
declare sub soundDeinit ()
declare sub setSoundVol ( soundVol as integer )
declare sub setMusicVol ( musicVol as integer )
declare sub playMp3 ( filename as string, looping as integer )
declare sub playDtile ( xd as double, yd as double, xv as double, yv as double, index as integer ) ' xd,dy : distance from camera
declare sub stopDtile ( index as integer )
declare sub stopMp3 ()
declare sub stopAllSounds ()
declare sub playSound ( sample as HSAMPLE )
declare sub playSoundEx ( sample as HSAMPLE, freq as integer, vol as integer, pan as integer )
declare sub playSoundExC ( sample as HSAMPLE, freq as integer, vol as integer, pan as integer, channel as integer, looping as integer )
declare sub stopSound ( channel as integer )
declare function loadSound ( file as string, mx as integer, flags as integer ) as HSAMPLE

dim shared soundOn as integer
dim shared channels(256) as HCHANNEL
dim shared channelVol(256) as integer
dim shared thisMusic as HSAMPLE
dim shared dtileSample as HSAMPLE, bounceSample as HSAMPLE, mineSample as HSAMPLE
dim shared explosionSample as HSAMPLE, tone2 as HSAMPLE
dim shared as HSAMPLE clickSample, dingSample
dim shared as integer curMusicVol, curSoundVol

'''''

'soundInit ( 60, 30 )
'playMp3 ( "music/track1menu.mp3", 1)
'''playMp3 ( "music/themeforantiman.mp3", 0 )
'
'do
'	dim as string ky = lcase$(inkey$)
'	playDtile( sin(timer)*5, sin(timer)*5, 0.25, 0.25, 1 )
'	playDtile( sin(timer*2)*5, sin(timer*2)*5, 0.5, 0.5, 2 )
'	if ky = "e" then playSoundEx ( explosionSample, 8000, 100, 0 )
'	if ky = "b" then playSoundEx ( bounceSample, 55100, 50, 0 )
'	if ky = "m" then
'		playSoundEx ( mineSample, 44100+(rnd*5000)-2500, 50, 0 )
'	end if
'	if multikey(&h39) then
'		playSoundExC ( dtileSample, 30000, 100, 0, 1, 1 )
'	else
'		stopSound ( 1 )
'	end if
'	if ky = chr$(27) then exit do
'loop
'
'soundDeinit

''''

sub soundInit ( soundVol as integer, musicVol as integer )
	
	if (BASS_Init(-1,44100,0,0,0) = 0) then
    	BASS_Init(0,44100,0,0,NULL)
    	soundOn = 0
	else
   		soundOn = 1
    end if

	curMusicVol = musicVol
	curSoundVol = soundVol

	dtileSample = loadSound ( "sounds/dtile.mp3", 32, 0 )
	explosionSample = loadSound ( "sounds/explosion.wav", 6, 0 )
	bounceSample = loadSound ( "sounds/bounce.wav", 16, 0 )
	mineSample = loadSound ( "sounds/mine.wav", 8, 0 )
	clickSample = loadSound ( "sounds/click.wav", 4, 0 )
	dingSample = loadSound ( "sounds/ding.wav", 4, 0 )
	tone2 = loadSound ( "sounds/tone2.wav", 8, 0 )

end sub

sub soundDeinit ()

	BASS_Free

	if thisMusic <> 0 then BASS_SampleFree thisMusic
	if dtileSample <> 0 then BASS_SampleFree dtileSample
	if explosionSample <> 0 then BASS_SampleFree explosionSample
	if bounceSample <> 0 then BASS_SampleFree bounceSample
	if mineSample <> 0 then BASS_SampleFree mineSample
	if clickSample <> 0 then BASS_SampleFree clickSample
	if dingSample <> 0 then BASS_SampleFree dingSample
	if tone2 <> 0 then BASS_SampleFree tone2

end sub

sub setSoundVol ( soundVol as integer )

	dim as integer i

	if soundVol < 0 then soundVol = 0

	curSoundVol = soundVol

	for i = 1 to 255
	
		if channels(i) <> 0 and BASS_ChannelIsActive(channels(i)) = BASS_ACTIVE_PLAYING then

			BASS_ChannelSetAttributes(channels(i), -1, (curSoundVol/100) * channelVol(i), -101)
			
		end if
	
	next i

end sub

sub setMusicVol ( musicVol as integer )

	if musicVol < 0 then musicVol = 0

	curMusicVol = musicVol

	if channels(0) <> 0 and BASS_ChannelIsActive(channels(0)) = BASS_ACTIVE_PLAYING then
		BASS_ChannelSetAttributes(channels(0), -1, curMusicVol, -101)
	end if

end sub

sub playMp3 ( filename as string, looping as integer )

	if channels(0) <> 0 and BASS_ChannelIsActive(channels(0)) = BASS_ACTIVE_PLAYING then
		BASS_ChannelPause(channels(0))
		BASS_ChannelStop(channels(0))
	end if

	if thisMusic <> 0 then

		BASS_SampleFree thisMusic
	
	end if

	dim flags as integer = 0

	if looping then flags = flags or BASS_SAMPLE_LOOP

	thisMusic = loadSound ( filename, 1, flags )

	channels(0) = BASS_SampleGetChannel(thisMusic, false)

	setMusicVol ( curMusicVol )
	BASS_ChannelSetAttributes(channels(0), -1, curMusicVol, -101)
	
	BASS_ChannelPlay(channels(0), true)

end sub

sub playDtile ( xd as double, yd as double, xv as double, yv as double, index as integer )

	dim as integer vol, pan, freq

	dim as double dist, speed

	dist = (sqr(xd*xd + yd*yd))
	speed = sqr(xv*xv + yv*yv)

	if dist < .001 then dist = .001

	vol = 50.0 / (dist*dist)

	if vol > 100 then vol = 100

	freq = 11100 + 22000 * speed
	pan = xd*10

	if pan > 99 then pan = 99
	if pan < -99 then pan = -99

	'open "log.txt" for append as #1: print #1, vol, dist: close #1

	playSoundExC(dtileSample, freq, vol, pan, 2+(index mod 127), 1)

end sub

sub stopDtile ( index as integer )

	dim as integer channel = 2+(index mod 127)

	stopSound( channel )
	
end sub

sub stopAllSounds ()

	dim as integer i
	for i = 1 to 255
		stopSound i
	next i

end sub

sub stopSound ( channel as integer )

	dim as integer status = BASS_ChannelIsActive(channels(channel))

	if status = BASS_ACTIVE_PLAYING then BASS_ChannelPause ( channels(channel) )

end sub

sub playSound ( sample as HSAMPLE )

	playSoundEx ( sample, -1, -1, -101 )

end sub

sub playSoundEx ( sample as HSAMPLE, freq as integer, vol as integer, pan as integer )

	if vol > -1 then
		vol = (curSoundVol/100.0) * vol
	else
		vol = curSoundVol
	end if
	
	dim as integer i

	for i = 129 to 255
	
		if channels(i) = 0 or BASS_ChannelIsActive(channels(i)) <> BASS_ACTIVE_PLAYING then
			
			channels(i) = BASS_SampleGetChannel(sample, false)
			channelVol(i) = vol

			BASS_ChannelSetAttributes(channels(i), freq, vol, pan)
			BASS_ChannelPlay(channels(i), 1)
			exit sub

		end if

		if i = 255 then
			i = 128
			channels(1) = 0
		end if
	
	next i

end sub

sub playSoundExC ( sample as HSAMPLE, freq as integer, vol as integer, pan as integer, channel as integer, looping as integer )

	if vol > -1 then
		vol = (curSoundVol/100.0) * vol
	else
		vol = curSoundVol
	end if

	if channels(channel) = 0 then
		channels(channel) = BASS_SampleGetChannel(sample, false)
		if looping then BASS_ChannelSetFlags(channels(channel), BASS_SAMPLE_LOOP)
	end if
	
	channelVol(channel) = vol

	BASS_ChannelSetAttributes(channels(channel), freq, vol, pan)
	if BASS_ChannelIsActive(channels(channel)) <> BASS_ACTIVE_PLAYING then BASS_ChannelPlay(channels(channel), 1)

end sub

sub stopMp3 ()

	if channels(0) <> 0 and BASS_ChannelIsActive(channels(0)) = BASS_ACTIVE_PLAYING then
		BASS_ChannelSetAttributes(channels(0), -1, 0, -101)
		BASS_ChannelStop(channels(0))
	end if

end sub

function loadSound ( file as string, mx as integer, flags as integer ) as HSAMPLE
       
	dim f as zstring * 128
        
	f = file
        
	return BASS_SampleLoad(0, f, 0, 0, mx, BASS_SAMPLE_OVER_POS or flags )
        
end function

