CONST true = -1

CONST pacman = 0
CONST blinky = 1
CONST pinky = 2
CONST inky = 3
CONST clyde = 4

CONST rightkey& = 19712
CONST downkey& = 20480
CONST leftkey& = 19200
CONST upkey& = 18432
CONST enterkey& = 13
CONST esckey& = 27

' *** offsets to change maze coordinates to screen coordinates
CONST maze2screenX = 119
CONST maze2screenY = 19

SCREEN _NEWIMAGE(800, 600, 32)

DIM SHARED level
DIM SHARED score
DIM SHARED hiscore
DIM SHARED dotsLeft
DIM SHARED lives
DIM SHARED freepac
DIM SHARED die
DIM SHARED xit
DIM SHARED gameMode
DIM SHARED whatsAhead(3)
DIM SHARED speedCounter(4)
DIM SHARED fruitStatus
DIM SHARED startTime

DIM SHARED titleMusic&
DIM SHARED frightMusic&

DIM SHARED backgroundMusic&

DIM SHARED startMusic&
startMusic& = _SNDOPEN("tronpacman\tron_start.wav", "sync")

DIM SHARED eating&
eating& = _SNDOPEN("tronpacman\wakka2.wav", "sync")

DIM SHARED eatrec&
eatrec& = _SNDOPEN("tronpacman\eating_ghost.wav", "sync")

DIM SHARED endgame&
endgame& = _SNDOPEN("tronpacman\dp_tron_end.wav", "sync")

DIM SHARED endofline&
endofline& = _SNDOPEN("tronpacman\endofline.wav", "sync")

' *** image handle for background behind pacman and recognizer sprites
DIM SHARED spriteBack&
spriteBack& = _NEWIMAGE(150, 60, 32)

' *** image handle for pacman sprite sheet
DIM SHARED sprite&
sprite& = _LOADIMAGE("tronpacman\PacSprites.png")
_CLEARCOLOR _RGB(0, 0, 0), sprite&

' *** image handle for spot to erase dots and discs
DIM SHARED dotmask&
dotmask& = _LOADIMAGE("tronpacman\dotmask.png")
_CLEARCOLOR _RGB(255, 255, 255), dotmask&

' *** image handle for font sprites
DIM SHARED spritefont&
spritefont& = _LOADIMAGE("tronpacman\smallfont.png")
_CLEARCOLOR _RGB(255, 255, 255), spritefont&

' *** screen coordinates for pacman and recognizers
DIM SHARED screenX(4), screenY(4)

' *** 5*2 array to hold the starting screen positions of pacman and recognizers
DIM SHARED startPositionX(4), startPositionY(4)
FOR a = pacman TO clyde
    READ startPositionX(a), startPositionY(a)
NEXT a
DATA 385,411
DATA 385,243
DATA 385,285
DATA 343,285
DATA 427,285

' *** maze coordinates of pacman and recognizers
DIM SHARED mazeX(4), mazeY(4)

' *** maze coordinates of recognizer targets
DIM SHARED targetX(4), targetY(4)

' *** recognizer sprite modes: 0-normal, 1-blue, 2-eaten
DIM SHARED recMode(4)

' *** two 4 element arrays to hold the x,y values of the recognizer scatter corners
DIM SHARED cornerX(4), cornerY(4)
FOR a = blinky TO clyde
    READ cornerX(a), cornerY(a)
NEXT a
DATA 31,13
DATA 7,13
DATA 28,28
DATA 10,28

' *** pacman and recognizer facing direction: 0-right, 1-down, 2-left, 3-up
DIM SHARED direction(4)

' *** two 4 element arrays to determine the change in X and Y coordinates based on direction
DIM SHARED startDirection(4)
FOR a = 0 TO 4
    READ startDirection(a)
NEXT a
DATA 0,2,3,0,2

' *** two 4 element arrays to determine the change in X and Y coordinates based on direction
DIM SHARED moveX(3), moveY(3)
FOR a = 0 TO 3
    READ moveX(a), moveY(a)
NEXT a
DATA 1,0
DATA 0,1
DATA -1,0
DATA 0,-1

' *** pacman chomping sequence step: 0-closed, 1-open a little, 2-open all the way, 4-open a little
DIM SHARED pacmanStep

' *** 4*8 array to determine which sprite on the sprite sheet to use based on direction(pacman), pacmanStep
DIM SHARED pacmanSprite(3, 7)
FOR y = 0 TO 7
    FOR x = 0 TO 3
        READ pacmanSprite(x, y)
    NEXT x
NEXT y

DATA 0,0,0,0
DATA 1,3,5,7
DATA 1,3,5,7
DATA 2,4,6,8
DATA 2,4,6,8
DATA 1,3,5,7
DATA 1,3,5,7
DATA 0,0,0,0

' *** 21*2 array to hold the sprite position and point value of the level bonuses
DIM SHARED levelBonus(21, 1)
FOR a = 1 TO 21
    READ levelBonus(a, 0), levelBonus(a, 1)
NEXT a
DATA 0,100
DATA 1,300
DATA 2,500
DATA 2,500
DATA 3,700
DATA 3,700
DATA 4,1000
DATA 4,1000
DATA 5,2000
DATA 5,2000
DATA 6,3000
DATA 6,3000
DATA 7,5000
DATA 7,5000
DATA 7,5000
DATA 7,5000
DATA 7,5000
DATA 7,5000
DATA 7,5000
DATA 7,5000
DATA 7,5000

' *** 21 * 9 array to hold the times that the frightened, scatter, and chase modes last per level
DIM SHARED levelModeTimes(21, 8)
FOR a = 1 TO 21
    FOR b = 0 TO 8
        READ levelModeTimes(a, b)
    NEXT b
NEXT a
DATA 6,7,27,34,54,59,79,84,0
DATA 5,7,27,34,54,59,1092,0,0
DATA 4,7,27,34,54,59,1092,0,0
DATA 3,7,27,34,54,59,1092,0,0
DATA 2,5,25,30,50,55,1092,0,0
DATA 5,5,25,30,50,55,1092,0,0
DATA 2,5,25,30,50,55,1092,0,0
DATA 2,5,25,30,50,55,1092,0,0
DATA 1,5,25,30,50,55,1092,0,0
DATA 5,5,25,30,50,55,1092,0,0
DATA 2,5,25,30,50,55,1092,0,0
DATA 1,5,25,30,50,55,1092,0,0
DATA 1,5,25,30,50,55,1092,0,0
DATA 3,5,25,30,50,55,1092,0,0
DATA 1,5,25,30,50,55,1092,0,0
DATA 1,5,25,30,50,55,1092,0,0
DATA 0,5,25,30,50,55,1092,0,0
DATA 1,5,25,30,50,55,1092,0,0
DATA 0,5,25,30,50,55,1092,0,0
DATA 0,5,25,30,50,55,1092,0,0
DATA 0,5,25,30,50,55,1092,0,0

' *** 5 element array (pacman + 4 recognizers) to hold the times when the recognizers leave their pen
DIM SHARED outTime(4)
FOR a = 0 TO 4
    READ outTime(a)
NEXT a
DATA 0,0,0,5,10

' *** 21*2 array to hold the relative speeds of pacman and the recognizers per level
DIM SHARED relativeSpeed(21, 1)
FOR a = 1 TO 21
    READ relativeSpeed(a, 0), relativeSpeed(a, 1)
NEXT a
DATA .533,.500
DATA .600,.567
DATA .600,.567
DATA .600,.567
DATA .667,.633
DATA .667,.633
DATA .667,.633
DATA .667,.633
DATA .667,.633
DATA .667,.633
DATA .667,.633
DATA .667,.633
DATA .667,.633
DATA .667,.633
DATA .667,.633
DATA .667,.633
DATA .667,.633
DATA .667,.633
DATA .667,.633
DATA .667,.633
DATA .600,.633

' *** Four 12 element arrays to hold the entrance and exit coordinates of all 12 tunnels
DIM SHARED tunnelEntranceX(12), tunnelEntranceY(12), tunnelExitX(12), tunnelExitY(12)
FOR a = 1 TO 12
    READ tunnelEntranceX(a), tunnelEntranceY(a), tunnelExitX(a), tunnelExitY(a)
NEXT a
DATA 385,19,385,537: ' *** top tunnel going up
DATA 371,33,637,285: ' *** top tunnel going left
DATA 399,33,133,285: ' *** top tunnel going right
DATA 385,551,385,33: ' *** bottom tunnel going down
DATA 371,537,637,285: ' *** bottom tunnel going left
DATA 399,537,133,285: ' *** bottom tunnel going right
DATA 119,285,637,285: ' *** left tunnel going left
DATA 133,271,385,537: ' *** left tunnel going up
DATA 133,299,385,33: ' *** left tunnel going down
DATA 651,285,133,285: ' *** right tunnel going right
DATA 637,271,385,537: ' *** right tunnel going up
DATA 637,299,385,33: ' *** right tunnel going down

DIM SHARED scorelist(11), initial$(11)
OPEN "tronpacman\hiscores.txt" FOR INPUT AS #1
FOR a = 1 TO 10
    INPUT #1, scorelist(a), initial$(a)
NEXT a
CLOSE #1

' *** 39*39 array to hold the maze for wall testing: 0=wall, 1=open, 2=open with dot, 3=open dot eaten
DIM SHARED maze(38, 38) AS INTEGER
FOR y = 0 TO 38
    FOR x = 0 TO 38
        READ maze(x, y)
    NEXT x
NEXT y

DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,6,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,0,0,6,0,0,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,2,0,0,6,0,0,2,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,2,0,0,1,0,0,2,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,2,2,2,2,2,2,2,0,0,2,2,2,2,2,2,2,0,0,2,2,2,2,2,2,2,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,2,0,0,2,0,0,2,0,0,2,0,0,0,0,0,2,0,0,2,0,0,2,0,0,2,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,2,0,0,2,0,0,2,0,0,2,0,0,0,0,0,2,0,0,2,0,0,2,0,0,2,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,4,0,0,2,0,0,2,2,2,2,2,2,2,2,2,2,2,2,2,0,0,2,0,0,4,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,2,0,0,2,0,0,2,0,0,0,0,0,0,0,0,0,0,0,2,0,0,2,0,0,2,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,2,0,0,2,0,0,2,0,0,0,0,0,0,0,0,0,0,0,2,0,0,2,0,0,2,0,0,0,0,0,0,0
DATA 0,0,0,0,2,2,2,2,2,2,2,0,0,2,2,2,2,0,0,0,0,0,2,2,2,2,0,0,2,2,2,2,2,2,2,0,0,0,0
DATA 0,0,0,0,2,0,0,0,0,0,2,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,0,0,2,0,0,0,0,0,2,0,0,0,0
DATA 0,0,0,0,2,0,0,0,0,0,2,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,0,0,2,0,0,0,0,0,2,0,0,0,0
DATA 0,0,0,0,2,2,2,2,2,2,2,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,2,2,2,2,2,2,2,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,2,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,2,0,0,0,0,0,0,0,0,0,0
DATA 0,6,0,0,0,0,0,0,0,0,2,0,0,1,0,0,0,0,0,7,0,0,0,0,0,1,0,0,2,0,0,0,0,0,0,0,0,6,0
DATA 6,6,6,6,6,6,6,6,6,1,2,1,1,1,0,0,7,7,7,7,7,7,7,0,0,1,1,1,2,1,6,6,6,6,6,6,6,6,6
DATA 0,6,0,0,0,0,0,0,0,0,2,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,2,0,0,0,0,0,0,0,0,6,0
DATA 0,0,0,0,0,0,0,0,0,0,2,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,2,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,2,2,2,2,2,2,2,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,2,2,2,2,2,2,2,0,0,0,0
DATA 0,0,0,0,2,0,0,0,0,0,2,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,2,0,0,0,0,0,2,0,0,0,0
DATA 0,0,0,0,2,0,0,0,0,0,2,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,2,0,0,0,0,0,2,0,0,0,0
DATA 0,0,0,0,2,2,2,4,0,0,2,2,2,2,2,2,2,0,0,0,0,0,2,2,2,2,2,2,2,0,0,4,2,2,2,0,0,0,0
DATA 0,0,0,0,0,0,0,2,0,0,2,0,0,0,0,0,2,0,0,0,0,0,2,0,0,0,0,0,2,0,0,2,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,2,0,0,2,0,0,0,0,0,2,0,0,0,0,0,2,0,0,0,0,0,2,0,0,2,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,2,2,2,2,0,0,2,2,2,2,2,1,1,1,2,2,2,2,2,0,0,2,2,2,2,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,2,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,2,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,2,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,2,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,2,2,2,2,2,2,2,0,0,2,2,2,2,2,2,2,0,0,2,2,2,2,2,2,2,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,2,0,0,1,0,0,2,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,2,0,0,6,0,0,2,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,0,0,6,0,0,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,6,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

DO
    TitleScreen
    IF xit = NOT true THEN PlayGame
LOOP UNTIL xit = true
SYSTEM

SUB TitleScreen ()
titleMusic& = _SNDOPEN("tronpacman\Tron_Arcade_Tower.mid", "vol")

_SNDLOOP titleMusic&
title& = _LOADIMAGE("tronpacman/titlescreen.png")
done = NOT true: xit = NOT true
startTimer = TIMER: displayCount = 0
DO
    _LIMIT 15
    IF _KEYDOWN(esckey&) THEN xit = true
    IF _KEYDOWN(enterkey&) THEN done = true

    IF TIMER < startTimer THEN startTimer = startTimer - 86400
    elapsed = TIMER - startTimer

    IF elapsed > 0 AND displayCount = 0 THEN
        displayCount = displayCount + 1
        _PUTIMAGE (0, 0), title&
        MenuAndCopyright
    END IF

    IF elapsed > 4.0 AND displayCount = 1 THEN
        displayCount = displayCount + 1
        CLS
        SpritePrint 16 + 6 * 24, 2 * 24, "CHARACTER", _RGB(255, 255, 255), 3
        MenuAndCopyright
    END IF
    IF elapsed > 4.5 AND displayCount = 2 THEN
        displayCount = displayCount + 1
        SpritePrint 16 + 16 * 24, 2 * 24, "/ NICKNAME", _RGB(255, 255, 255), 3
    END IF

    IF elapsed > 5.0 AND displayCount = 3 THEN
        displayCount = displayCount + 1
        _PUTIMAGE (16 + 5 * 24, 4 * 24 - 3), sprite&, 0, (2 * 30, 30)-(2 * 30 + 29, 59)
    END IF
    IF elapsed > 5.5 AND displayCount = 4 THEN
        displayCount = displayCount + 1
        SpritePrint 16 + 7 * 24, 4 * 24, "UNIT#5H4D0", _RGB(200, 0, 0), 3
    END IF
    IF elapsed > 6.0 AND displayCount = 5 THEN
        displayCount = displayCount + 1
        SpritePrint 16 + 19 * 24, 4 * 24, "[BLINKY]", _RGB(200, 0, 0), 3
    END IF

    IF elapsed > 6.5 AND displayCount = 6 THEN
        displayCount = displayCount + 1
        _PUTIMAGE (16 + 5 * 24, 6 * 24 - 3), sprite&, 0, (3 * 30, 30)-(3 * 30 + 29, 59)
    END IF
    IF elapsed > 7.0 AND displayCount = 7 THEN
        displayCount = displayCount + 1
        SpritePrint 16 + 7 * 24, 6 * 24, "UNIT#5PD33", _RGB(255, 140, 255), 3
    END IF
    IF elapsed > 7.5 AND displayCount = 8 THEN
        displayCount = displayCount + 1
        SpritePrint 16 + 19 * 24, 6 * 24, "[PINKY]", _RGB(255, 140, 255), 3
    END IF

    IF elapsed > 8.0 AND displayCount = 9 THEN
        displayCount = displayCount + 1
        _PUTIMAGE (16 + 5 * 24, 8 * 24 - 3), sprite&, 0, (4 * 30, 30)-(4 * 30 + 29, 59)
    END IF
    IF elapsed > 8.5 AND displayCount = 10 THEN
        displayCount = displayCount + 1
        SpritePrint 16 + 7 * 24, 8 * 24, "UNIT#85HF1", _RGB(100, 200, 255), 3
    END IF
    IF elapsed > 9.0 AND displayCount = 11 THEN
        displayCount = displayCount + 1
        SpritePrint 16 + 19 * 24, 8 * 24, "[INKY]", _RGB(100, 200, 255), 3
    END IF

    IF elapsed > 9.5 AND displayCount = 12 THEN
        displayCount = displayCount + 1
        _PUTIMAGE (16 + 5 * 24, 10 * 24 - 3), sprite&, 0, (5 * 30, 30)-(5 * 30 + 29, 59)
    END IF
    IF elapsed > 10.0 AND displayCount = 13 THEN
        displayCount = displayCount + 1
        SpritePrint 16 + 7 * 24, 10 * 24, "UNIT#P0K33", _RGB(255, 180, 64), 3
    END IF
    IF elapsed > 10.5 AND displayCount = 14 THEN
        displayCount = displayCount + 1
        SpritePrint 16 + 19 * 24, 10 * 24, "[CLYDE]", _RGB(255, 180, 64), 3
    END IF

    IF elapsed > 11.0 AND displayCount = 15 THEN
        displayCount = displayCount + 1
        _PUTIMAGE (16 + 11 * 24, 15 * 24), sprite&, 0, (0 * 30, 30)-(0 * 30 + 29, 59)
        _PUTIMAGE (16 + 11 * 24, 16 * 24), sprite&, 0, (1 * 30, 30)-(1 * 30 + 29, 59)
        SpritePrint 16 + 13 * 24, 15 * 24, "10 PTS", _RGB(255, 255, 255), 3
        SpritePrint 16 + 13 * 24, 16 * 24, "50 PTS", _RGB(255, 255, 255), 3
    END IF

    IF elapsed > 15.0 AND displayCount = 16 THEN
        displayCount = displayCount + 1
        CLS
        SpritePrint 16 + 10 * 24, 1 * 24, "HIGH SCORERS", _RGB(255, 255, 255), 3
        MenuAndCopyright
    END IF
    FOR a = 1 TO 10
        IF elapsed > 15 + (.5 * a) AND displayCount = 16 + a THEN
            displayCount = displayCount + 1
            score$ = STR$(scorelist(a)): l = LEN(score$)
            SpritePrint 16 + (16 - l) * 24, (1.5 + (a * 1.5)) * 24, score$, _RGB(200, 200, 200), 3
            SpritePrint 16 + 18 * 24, (1.5 + (a * 1.5)) * 24, initial$(a), _RGB(127, 255, 255), 3
        END IF
    NEXT a

    IF elapsed > 25 THEN
        startTimer = TIMER
        displayCount = 0
    END IF
LOOP UNTIL done OR xit
_FREEIMAGE title&
_SNDSTOP titleMusic&
_SNDCLOSE titleMusic&
END SUB

SUB PlayGame ()
' *** starting a new game ***
level = 1: score = 0: hiscore = scorelist(1): lives = 3: freepac = 5
_SNDPLAY startMusic&
NewLevelSetup
DO
    StartPositionSetup
    MainLoop
    FOR a = pacman TO clyde
        EraseSprite a
    NEXT a
    IF die = true THEN
        lives = lives - 1
        DeRezz
    END IF
    IF dotsLeft = NOT true THEN
        FlashScreen
        level = level + 1
        IF level > 21 THEN level = 21
        NewLevelSetup
    END IF
LOOP WHILE lives > 0 AND xit = NOT true
GameOver
xit = NOT true
END SUB

SUB NewLevelSetup ()
dotsLeft = 255
FOR y = 0 TO 38
    FOR x = 0 TO 38
        IF maze(x, y) = 3 THEN maze(x, y) = 2
        IF maze(x, y) = 5 THEN maze(x, y) = 4
    NEXT x
NEXT y
END SUB

SUB StartPositionSetup ()
die = NOT true
gameMode = 1
fruitStatus = 0
map& = _LOADIMAGE("tronpacman/newfullscreen.png")
_PUTIMAGE (0, 0), map&
_FREEIMAGE map&
FOR y = 0 TO 38
    FOR x = 0 TO 38
        IF maze(x, y) = 2 THEN _PUTIMAGE (x * 14 + maze2screenX, y * 14 + maze2screenY), sprite&, 0, (0, 30)-(29, 59)
        IF maze(x, y) = 4 THEN _PUTIMAGE (x * 14 + maze2screenX, y * 14 + maze2screenY), sprite&, 0, (30, 30)-(59, 59)
    NEXT x
NEXT y
FOR a = pacman TO clyde
    screenX(a) = startPositionX(a)
    screenY(a) = startPositionY(a)
    mazeX(a) = (screenX(a) - maze2screenX) \ 14
    mazeY(a) = (screenY(a) - maze2screenY) \ 14
    direction(a) = startDirection(a)
    recMode(a) = 0
NEXT a
pacmanStep = 0
AddScore 0

' *** Display lives left ***
IF lives > 1 THEN
    FOR a = 1 TO lives - 1
        _PUTIMAGE (97 + a * 30, 543), sprite&, 0, (150, 0)-(179, 29)
    NEXT a
END IF
' *** Display level sprite ***
startlevel = 1
IF level > 7 THEN startlevel = level - 6
x = 643
FOR a = startlevel TO level
    _PUTIMAGE (x, 543), sprite&, 0, (levelBonus(a, 0) * 30, 60)-(levelBonus(a, 0) * 30 + 29, 89)
    x = x - 30
NEXT a
_PUTIMAGE (0, 30)-(143, 30 + 23), 0, spriteBack&, (16 + 13 * 24, 330)-(16 + 13 * 24 + 143, 330 + 23)
SpritePrint 16 + 13 * 24, 330, "READY!", _RGB(250, 0, 0), 3
Rezzup
EraseSprite pacman
DrawSprites
_DELAY 3.5
_PUTIMAGE (16 + 13 * 24, 330), spriteBack&, 0, (0, 30)-(143, 30 + 23)
END SUB

SUB MainLoop ()
done = NOT true
startTime = TIMER
backgroundMusic& = _SNDOPEN("tronpacman\pacman_siren.mp3")
frightMusic& = _SNDOPEN("tronpacman\dp_tron_panic.wav", "sync")
_SNDLOOP backgroundMusic&
fright = NOT true
loopCounter = 0

DO: ' *** Main Loop ***
    _LIMIT 60
    IF loopCounter = 0 THEN
        FOR a = pacman TO clyde
            speedCounter(a) = 0
        NEXT a
    END IF

    IF _KEYDOWN(esckey&) THEN
        done = true: xit = true
    END IF

    ' *** set gamemode to either scatter or chase depending on timer
    IF TIMER < startTime THEN startTime = startTime - 86400
    IF TIMER - startTime >= levelModeTimes(level, gameMode) AND gameMode < 8 THEN
        ChangeDirection
        gameMode = gameMode + 1
    END IF

    IF fruitStatus = 1 OR fruitStatus = 3 THEN
        _PUTIMAGE (385, 327)-(385 + 29, 327 + 29), spriteBack&, 0, (0, 30)-(29, 59)
    END IF

    SetRecognizerTarget

    ' *** get player and computer moves ***
    FOR a = pacman TO clyde
        EraseSprite a
        oldCounter = INT(speedCounter(a))
        IF a = 0 THEN z = 0 ELSE z = 1
        speed = relativeSpeed(level, z)
        IF recMode(a) = 1 OR recMode(a) = 2 THEN speed = speed / 2
        IF recMode(a) = 3 THEN speed = 1
        IF a > 0 AND maze(mazeX(a), mazeY(a)) = 6 THEN speed = relativeSpeed(level, 1) / 2
        speedCounter(a) = speedCounter(a) + speed
        IF INT(speedCounter(a)) > oldCounter THEN
            SELECT CASE a
                CASE 0
                    GetPlayerMove
                CASE ELSE
                    GetComputerMove a
            END SELECT
        END IF
    NEXT a

    ' *** Checking if pacman or the recognizers go through a tunnel
    FOR a = pacman TO clyde
        FOR b = 1 TO 12
            IF screenX(a) = tunnelEntranceX(b) AND screenY(a) = tunnelEntranceY(b) THEN
                screenX(a) = tunnelExitX(b): screenY(a) = tunnelExitY(b)
                mazeX(a) = (screenX(a) - maze2screenX) \ 14
                mazeY(a) = (screenY(a) - maze2screenY) \ 14
            END IF
        NEXT b
    NEXT a

    ' *** Check if level bonus (fruit) should be displayed
    IF (fruitStatus = 0 AND dotsLeft = 185) OR (fruitStatus = 2 AND dotsLeft = 85) THEN
        fruitStatus = fruitStatus + 1
        bonusTimer = TIMER
    END IF

    ' *** Turn off level bonus (fruit) if it's time
    IF fruitStatus = 1 OR fruitStatus = 3 THEN
        IF TIMER < bonusTimer THEN bonusTimer = bonusTimer - 86400
        IF TIMER - bonusTimer >= 10 THEN
            fruitStatus = fruitStatus + 1
        END IF
    END IF

    IF fright = true THEN
        IF TIMER < frightTimer THEN frightTimer = frightTimer - 86400
        timeleft = levelModeTimes(level, 0) - (TIMER - frightTimer)
        SELECT CASE timeleft
            CASE IS < 0
                FOR a = blinky TO clyde
                    IF recMode(a) = 2 THEN recMode(a) = 0
                NEXT a
                fright = NOT true
                _SNDSTOP frightMusic&
                _SNDLOOP backgroundMusic&
            CASE 0 TO .2
                FOR a = blinky TO clyde
                    IF recMode(a) = 1 THEN recMode(a) = 2
                NEXT a
            CASE .2 TO .4
                FOR a = blinky TO clyde
                    IF recMode(a) = 2 THEN recMode(a) = 1
                NEXT a
            CASE .4 TO .6
                FOR a = blinky TO clyde
                    IF recMode(a) = 1 THEN recMode(a) = 2
                NEXT a
            CASE .6 TO .8
                FOR a = blinky TO clyde
                    IF recMode(a) = 2 THEN recMode(a) = 1
                NEXT a
            CASE .8 TO 1
                FOR a = blinky TO clyde
                    IF recMode(a) = 1 THEN recMode(a) = 2
                NEXT a
        END SELECT
    END IF

    ' *** check if eaten recognizer made it back home
    FOR a = blinky TO clyde
        IF recMode(a) = 3 THEN
            IF mazeX(a) = targetX(a) AND mazeY(a) = targetY(a) THEN
                recMode(a) = 0
                direction(a) = startDirection(a)
            END IF
        END IF
    NEXT a

    ' *** check if pacman eats a level bonus
    IF fruitStatus = 1 OR fruitStatus = 3 THEN
        IF mazeX(pacman) = 19 AND mazeY(pacman) = 22 THEN
            _SNDPLAYCOPY eating&
            fruitStatus = fruitStatus + 1
            AddScore levelBonus(level, 1)
        END IF
    END IF

    ' *** check if pacman eats a dot
    IF maze(mazeX(pacman), mazeY(pacman)) = 2 THEN
        _SNDPLAYCOPY eating&
        _PUTIMAGE (mazeX(pacman) * 14 + maze2screenX, mazeY(pacman) * 14 + maze2screenY), dotmask&, 0, (0, 0)-(29, 29)
        maze(mazeX(pacman), mazeY(pacman)) = 3
        AddScore 10
        dotsLeft = dotsLeft - 1
    END IF

    ' *** check if pacman eats a disc
    IF maze(mazeX(pacman), mazeY(pacman)) = 4 THEN
        _SNDPLAYCOPY eating&
        _SNDSTOP backgroundMusic&
        _PUTIMAGE (mazeX(pacman) * 14 + maze2screenX, mazeY(pacman) * 14 + maze2screenY), dotmask&, 0, (30, 0)-(59, 29)
        maze(mazeX(pacman), mazeY(pacman)) = 5
        AddScore 50
        dotsLeft = dotsLeft - 1
        ChangeDirection
        FOR a = blinky TO clyde
            IF recMode(a) = 0 THEN recMode(a) = 1
        NEXT a
        frightTimer = TIMER
        fright = true
        recseaten = 0
        _SNDLOOP frightMusic&
    END IF

    ' *** check for pacman / recognizer collision
    FOR a = blinky TO clyde
        IF mazeX(a) = mazeX(pacman) AND mazeY(a) = mazeY(pacman) THEN
            SELECT CASE recMode(a)
                CASE 0
                    die = true: done = true
                CASE 1 TO 2
                    _SNDPLAYCOPY eatrec&
                    recseaten = recseaten + 1
                    amount = 2 ^ recseaten * 100
                    AddScore amount
                    recMode(a) = 3
            END SELECT
        END IF
    NEXT a

    ' *** check if level is over
    IF dotsLeft = 0 THEN done = true

    DrawSprites
    _DISPLAY
    loopCounter = loopCounter + 1
    IF loopCounter = 60 THEN loopCounter = 0
LOOP UNTIL done = true
_SNDSTOP backgroundMusic&
_SNDCLOSE backgroundMusic&
_AUTODISPLAY
_DELAY 1
END SUB

SUB DrawSprites ()
' *** save what's behind the sprite for later ***
FOR a = pacman TO clyde
    _PUTIMAGE (a * 30, 0)-(a * 30 + 29, 29), 0, spriteBack&, (screenX(a), screenY(a))-(screenX(a) + 29, screenY(a) + 29)
NEXT a
IF fruitStatus = 1 OR fruitStatus = 3 THEN
    _PUTIMAGE (0, 30)-(29, 59), 0, spriteBack&, (385, 327)-(385 + 29, 327 + 29)
END IF
' *** actually draw each sprite ***
IF fruitStatus = 1 OR fruitStatus = 3 THEN
    fruit = levelBonus(level, 0)
    _PUTIMAGE (385, 327)-(385 + 29, 327 + 29), sprite&, 0, (fruit * 30, 60)-(fruit * 30 + 29, 89)
END IF
FOR a = pacman TO clyde
    IF mazeX(a) > 1 AND mazeX(a) < 37 AND mazeY(a) > 1 AND mazeY(a) < 37 THEN
        SELECT CASE a
            CASE 0
                sprite = pacmanSprite(direction(pacman), pacmanStep)
                _PUTIMAGE (screenX(a), screenY(a)), sprite&, 0, (sprite * 30, 0)-(sprite * 30 + 29, 29)
            CASE 1 TO 4
                sprite = a + 1
                IF recMode(a) = 1 THEN sprite = 6
                IF recMode(a) = 2 THEN sprite = 7
                IF recMode(a) = 3 THEN sprite = 8
                _PUTIMAGE (screenX(a), screenY(a)), sprite&, 0, (sprite * 30, 30)-(sprite * 30 + 29, 59)
        END SELECT
    END IF
NEXT a
_PUTIMAGE (127 + 18 * 14, 27 + 0 * 14)-(127 + 18 * 14 + 41, 27 + 0 * 14 + 41), sprite&, 0, (8 * 30, 60)-(8 * 30 + 29, 89)
_PUTIMAGE (127 + 18 * 14, 27 + 36 * 14)-(127 + 18 * 14 + 41, 27 + 36 * 14 + 41), sprite&, 0, (8 * 30, 60)-(8 * 30 + 29, 89)
_PUTIMAGE (127 + 0 * 14, 27 + 18 * 14)-(127 + 0 * 14 + 41, 27 + 18 * 14 + 41), sprite&, 0, (8 * 30, 60)-(8 * 30 + 29, 89)
_PUTIMAGE (127 + 36 * 14, 27 + 18 * 14)-(127 + 36 * 14 + 41, 27 + 18 * 14 + 41), sprite&, 0, (8 * 30, 60)-(8 * 30 + 29, 89)
END SUB

SUB EraseSprite (sprite)
_PUTIMAGE (screenX(sprite), screenY(sprite)), spriteBack&, 0, (sprite * 30, 0)-(sprite * 30 + 29, 29)
END SUB

SUB DeRezz ()
FOR a = 0 TO 8
    _PUTIMAGE (screenX(pacman), screenY(pacman)), sprite&, 0, (a * 30, 90)-(a * 30 + 29, 119)
    _DELAY .1
    _PUTIMAGE (screenX(pacman), screenY(pacman)), spriteBack&, 0, (0, 0)-(29, 29)
NEXT a
END SUB

SUB Rezzup ()
_PUTIMAGE (0, 0)-(29, 29), 0, spriteBack&, (screenX(pacman), screenY(pacman))-(screenX(pacman) + 29, screenY(pacman) + 29)
FOR a = 8 TO 0 STEP -1
    _PUTIMAGE (screenX(pacman), screenY(pacman)), sprite&, 0, (a * 30, 90)-(a * 30 + 29, 119)
    _DELAY .1
    _PUTIMAGE (screenX(pacman), screenY(pacman)), spriteBack&, 0, (0, 0)-(29, 29)
NEXT a
END SUB

SUB FlashScreen ()
flash& = _LOADIMAGE("tronpacman/newfullscreenflash.png")
map& = _LOADIMAGE("tronpacman/newfullscreen.png")
FOR a = 1 TO 2
    _PUTIMAGE (0, 0), flash&
    _DELAY .25
    _PUTIMAGE (0, 0), map&
    _DELAY .25
NEXT a
_PUTIMAGE (0, 0), flash&
_DELAY .25
_FREEIMAGE map&
_FREEIMAGE flash&
END SUB

SUB GameOver ()
_SNDPLAY endgame&
_PUTIMAGE (385, 285)-(385 + 29, 285 + 29), sprite&, 0, (7 * 30, 60)-(7 * 30 + 29, 89)
SpritePrint 292, 330, "GAME OVER", _RGB(250, 0, 0), 3
_DELAY 4.5
_SNDPLAY endofline&
_DELAY 1.5
IF score > scorelist(10) THEN AddNewHiScore
END SUB

SUB SpritePrint (x, y, text$, textcol&, scale)
FOR a = 1 TO LEN(text$)
    v = ASC(MID$(text$, a, 1)) - 32
    spriterow = (v \ 8) * 8
    spritecol = (v MOD 8) * 8
    size = (scale * 8) - 1
    LINE (x, y)-(x + size, y + size), textcol&, BF
    _PUTIMAGE (x, y)-(x + size, y + size), spritefont&, 0, (spritecol, spriterow)-(spritecol + 7, spriterow + 7)
    x = x + size + 1
NEXT a
END SUB

SUB AddScore (amount)
score = score + amount
IF score > hiscore THEN hiscore = score
SpritePrint 139, 24, "SCORE", _RGB(250, 250, 250), 3
SpritePrint 127, 48, RIGHT$(STR$(1000000 + score), 6), _RGB(250, 250, 250), 3
SpritePrint 505, 24, "HISCORE", _RGB(250, 250, 250), 3
SpritePrint 517, 48, RIGHT$(STR$(1000000 + hiscore), 6), _RGB(250, 250, 250), 3
IF score \ 1000 >= freepac THEN
    lives = lives + 1
    freepac = freepac + 5
    IF lives > 7 THEN lives = 7
    FOR a = 1 TO lives - 1
        _PUTIMAGE (97 + a * 30, 543), sprite&, 0, (150, 0)-(179, 29)
    NEXT a
END IF
END SUB

SUB ChangeDirection ()
FOR a = blinky TO clyde
    IF maze(mazeX(a), mazeY(a)) <> 7 AND recMode(a) < 3 THEN
        direction(a) = (direction(a) + 2) MOD 4
    END IF
NEXT a
END SUB

FUNCTION ChaseAI (recX, recY, gostraight, mode, targetX, targetY)
currentgrid = maze(recX, recY)
gostraightX = recX + moveX(gostraight)
gostraightY = recY + moveY(gostraight)
Xdifference = targetX - gostraightX
Ydifference = targetY - gostraightY
gostraightdistance = Xdifference ^ 2 + Ydifference ^ 2
gostraightgrid = maze(gostraightX, gostraightY)
IF gostraightX = 19 AND gostraightY = 17 AND (currentgrid = 7 OR mode = 3) THEN gostraightgrid = 1
turnleft = (gostraight + 3) MOD 4
turnleftX = recX + moveX(turnleft)
turnleftY = recY + moveY(turnleft)
Xdifference = targetX - turnleftX
Ydifference = targetY - turnleftY
turnleftdistance = Xdifference ^ 2 + Ydifference ^ 2
turnleftgrid = maze(turnleftX, turnleftY)
IF turnleftX = 19 AND turnleftY = 17 AND (currentgrid = 7 OR mode = 3) THEN turnleftgrid = 1
turnright = (gostraight + 1) MOD 4
turnrightX = recX + moveX(turnright)
turnrightY = recY + moveY(turnright)
Xdifference = targetX - turnrightX
Ydifference = targetY - turnrightY
turnrightdistance = Xdifference ^ 2 + Ydifference ^ 2
turnrightgrid = maze(turnrightX, turnrightY)
IF turnrightX = 19 AND turnrightY = 17 AND (currentgrid = 7 OR mode = 3) THEN turnrightgrid = 1

IF gostraightgrid <> 0 THEN
    newDirection = gostraight
    IF turnleftgrid <> 0 THEN
        IF turnleftdistance < gostraightdistance THEN newDirection = turnleft
        IF turnrightgrid <> 0 THEN
            IF turnrightdistance < turnleftdistance THEN newDirection = turnright
        END IF
    END IF
    IF turnrightgrid <> 0 THEN
        IF turnrightdistance < gostraightdistance THEN newDirection = turnright
        IF turnleftgrid <> 0 THEN
            IF turnleftdistance < turnrightdistance THEN newDirection = turnleft
        END IF
    END IF
ELSE
    IF turnleftgrid <> 0 THEN
        newDirection = turnleft
        IF turnrightgrid <> 0 THEN
            IF turnrightdistance < turnleftdistance THEN newDirection = turnright
        END IF
    ELSE
        newDirection = turnright
    END IF
END IF
ChaseAI = newDirection
END FUNCTION

SUB GetPlayerMove
chomp = true
x = screenX(pacman) - maze2screenX: y = screenY(pacman) - maze2screenY
IF x MOD 14 = 0 AND y MOD 14 = 0 THEN
    FOR a = 0 TO 3
        whatsAhead(a) = maze(mazeX(pacman) + moveX(a), mazeY(pacman) + moveY(a))
    NEXT a
    IF _KEYDOWN(rightkey&) AND whatsAhead(0) THEN direction(pacman) = 0
    IF _KEYDOWN(downkey&) AND whatsAhead(1) THEN direction(pacman) = 1
    IF _KEYDOWN(leftkey&) AND whatsAhead(2) THEN direction(pacman) = 2
    IF _KEYDOWN(upkey&) AND whatsAhead(3) THEN direction(pacman) = 3
    IF whatsAhead(direction(pacman)) = 0 THEN chomp = NOT true
END IF
IF chomp THEN
    screenX(pacman) = screenX(pacman) + (moveX(direction(pacman)) * 2)
    screenY(pacman) = screenY(pacman) + (moveY(direction(pacman)) * 2)
    mazeX(pacman) = (screenX(pacman) - maze2screenX) \ 14
    mazeY(pacman) = (screenY(pacman) - maze2screenY) \ 14
    pacmanStep = (pacmanStep + 1) MOD 8
END IF
END SUB

SUB SetRecognizerTarget
FOR a = blinky TO clyde
    IF recMode(a) = 3 THEN
        targetX(a) = (startPositionX(a) - maze2screenX) \ 14
        targetY(a) = (startPositionY(a) - maze2screenY) \ 14
        IF a = blinky THEN
            targetX(a) = (startPositionX(pinky) - maze2screenX) \ 14
            targetY(a) = (startPositionY(pinky) - maze2screenY) \ 14
        END IF
    ELSE
        IF maze(mazeX(a), mazeY(a)) = 7 THEN
            targetX(a) = 19: targetY(a) = 16
        ELSE
            IF gameMode MOD 2 = 1 THEN
                targetX(a) = cornerX(a): targetY(a) = cornerY(a)
            ELSE
                SELECT CASE a
                    CASE blinky
                        targetX(blinky) = mazeX(pacman): targetY(blinky) = mazeY(pacman)
                    CASE pinky
                        targetX(pinky) = mazeX(pacman) + moveX(direction(pacman)) * 4
                        targetY(pinky) = mazeY(pacman) + moveX(direction(pacman)) * 4
                    CASE inky
                        targetX(inky) = mazeX(pacman): targetY(inky) = mazeY(pacman)
                    CASE clyde
                        Xdifference = mazeX(pacman) - mazeX(clyde)
                        Ydifference = mazeY(pacman) - mazeY(clyde)
                        clydeDistance = INT(SQR(Xdifference ^ 2 + Ydifference ^ 2))
                        IF clydeDistance < 8 THEN
                            targetX(clyde) = cornerX(clyde): targetY(clyde) = cornerY(clyde)
                        ELSE
                            targetX(clyde) = mazeX(pacman): targetY(clyde) = mazeY(pacman)
                        END IF
                END SELECT
            END IF
        END IF
    END IF
NEXT a
END SUB

SUB GetComputerMove (a)
IF TIMER < startTime THEN startTime = startTime - 86400
IF TIMER - startTime >= outTime(a) THEN
    x = screenX(a) - maze2screenX: y = screenY(a) - maze2screenY
    IF x MOD 14 = 0 AND y MOD 14 = 0 AND maze(mazeX(a), mazeY(a)) <> 6 THEN
        direction(a) = ChaseAI((mazeX(a)), (mazeY(a)), (direction(a)), (recMode(a)), (targetX(a)), (targetY(a)))
    END IF
    screenX(a) = screenX(a) + (moveX(direction(a)) * 2)
    screenY(a) = screenY(a) + (moveY(direction(a)) * 2)
    mazeX(a) = (screenX(a) - maze2screenX) \ 14
    mazeY(a) = (screenY(a) - maze2screenY) \ 14
END IF
END SUB

SUB MenuAndCopyright
SpritePrint 16 + 6 * 24, 19 * 24, "PRESS ENTER TO START", _RGB(255, 255, 255), 3
SpritePrint 16 + 6 * 24, 21 * 24, "OR PRESS ESC TO EXIT", _RGB(180, 180, 180), 3
SpritePrint 19 * 8, 72 * 8, "(C) 2011 BY DANIEL [THEOPHAGE] CLARK - THEOPHAGE@GEOCITIES.COM", _RGB(127, 127, 127), 1
SpritePrint 2.5 * 8, 74 * 8, "TRON AND PACMAN PROPERTIES ARE (C) THEIR RESPECTIVE OWNERS AND ARE USED HERE WITHOUT PERMISSION", _RGB(127, 127, 127), 1
SpritePrint 2.5 * 8, 74 * 8, "TRON", _RGB(200, 200, 200), 1
SpritePrint 11.5 * 8, 74 * 8, "PACMAN", _RGB(200, 200, 200), 1
END SUB

SUB AddNewHiScore
DIM choice(2), letter$(2)
FOR a = 10 TO 1 STEP -1
    IF score > scorelist(a) THEN
        place = a
        scorelist(a + 1) = scorelist(a): initial$(a + 1) = initial$(a)
        scorelist(a) = score: initial$(a) = "   "
    END IF
NEXT a
CLS
SpritePrint 16 + 10 * 24, 1 * 24, "HIGH SCORERS", _RGB(255, 255, 255), 3
FOR a = 1 TO 10
    score$ = STR$(scorelist(a)): l = LEN(score$)
    SpritePrint 16 + (16 - l) * 24, (1.5 + (a * 1.5)) * 24, score$, _RGB(200, 200, 200), 3
    SpritePrint 16 + 18 * 24, (1.5 + (a * 1.5)) * 24, initial$(a), _RGB(127, 255, 255), 3
NEXT a
SpritePrint 16 + 6 * 24, 19 * 24, "USE ARROWS TO SELECT", _RGB(255, 255, 255), 3
SpritePrint 16 + 6 * 24, 21 * 24, "PRESS ENTER TO FINISH", _RGB(180, 180, 180), 3

done = NOT true
letterList$ = " ABCDEFGHIJKLMNOPQRSTUVWXYZ"
letterpos = 0
FOR a = 0 TO 2
    choice(a) = 0
    letter$(a) = " "
NEXT a
xpos = 16 + 18 * 24: y = (1.5 + (place * 1.5)) * 24

DO
    _LIMIT 5
    letter$(letterpos) = MID$(letterList$, choice(letterpos) + 1, 1)
    initial$(place) = letter$(0) + letter$(1) + letter$(2)
    SpritePrint (xpos), (y), initial$(place), _RGB(127, 255, 255), 3
    SpritePrint ((xpos) + letterpos * 24), (y), letter$(letterpos), _RGB(255, 255, 255), 3
    IF letter$(letterpos) = " " THEN
        _PUTIMAGE (xpos + letterpos * 24, y)-(xpos + letterpos * 24 + 23, y + 23), sprite&, 0, (8 * 30, 60)-(8 * 30 + 29, 89)
    END IF
    IF _KEYDOWN(rightkey&) THEN
        letterpos = (letterpos + 1) MOD 3
        _SNDPLAYCOPY eating&
    END IF
    IF _KEYDOWN(leftkey&) THEN
        letterpos = (letterpos + 2) MOD 3
        _SNDPLAYCOPY eating&
    END IF
    IF _KEYDOWN(upkey&) THEN
        choice(letterpos) = (choice(letterpos) + 1) MOD 27
        _SNDPLAYCOPY eating&
    END IF
    IF _KEYDOWN(downkey&) THEN
        choice(letterpos) = (choice(letterpos) + 26) MOD 27
        _SNDPLAYCOPY eating&
    END IF
    IF _KEYDOWN(enterkey&) THEN
        done = true
        _SNDPLAYCOPY endofline&
    END IF
LOOP UNTIL done

OPEN "tronpacman\hiscores.txt" FOR OUTPUT AS #1
FOR a = 1 TO 10
    WRITE #1, scorelist(a), initial$(a)
NEXT a
CLOSE #1

_DELAY 1
END SUB
